#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=C:\Program Files (x86)\AutoIt3\Icons\filetype-blank.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Auto-Typer
#AutoIt3Wrapper_Res_Fileversion=1.0.0.9
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GUIListBox.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
;#include <Array.au3>

dim $ver="Auto-Typer v1.0.0.9 Beta",$actions[1][6],$empty=true,$delay=200,$changed=0,$pause=false,$stop=false,$hotkeys[3]=["","",""],$oldhotkeys[3]=["","",""],$olddelay=200,$running=false,$justdisabled=false,$hidden=1
;actions: 1=# of times to run, 2=hotkey, 3=text, 4=default/custom, 5=custom delay, 6=press enter at end of text

$Form1 = GUICreate($ver, 617, 361, -1, -1)
$List1 = GUICtrlCreateList("", 8, 32, 249, 201)
$Label1 = GUICtrlCreateLabel("List of actions:", 10, 8, 72, 17)
$Group1 = GUICtrlCreateGroup("Change settings for selected actions:", 264, 8, 345, 225)
$Label2 = GUICtrlCreateLabel("Text to type:", 274, 96, 63, 17)
$Checkbox1 = GUICtrlCreateCheckbox("Press the enter key after this text", 424, 94, 177, 17)
$Input1 = GUICtrlCreateInput("", 272, 118, 329, 21)
$Group3 = GUICtrlCreateGroup("Delay in ms before action is executed:", 272, 152, 201, 73)
$Radio1 = GUICtrlCreateRadio("Use default delay", 280, 172, 169, 17)
$Radio2 = GUICtrlCreateRadio("Custom:", 280, 196, 57, 17)
$Input4 = GUICtrlCreateInput("200", 344, 194, 105, 21)
$updown1 = GUICtrlCreateUpdown($Input4, 0xA4)
GUICtrlSetLimit($updown1, 32767, 0)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Label5 = GUICtrlCreateLabel("Number of times to execute this action:", 274, 32, 187, 17)
$Input7 = GUICtrlCreateInput("1", 464, 30, 105, 21)
$updown2 = GUICtrlCreateUpdown($Input7, 0xA4)
GUICtrlSetLimit($updown2, 32767, 0)
$Label8 = GUICtrlCreateLabel("Hotkey to execute this action:", 274, 64, 145, 17)
$Input8 = GUICtrlCreateInput("", 424, 62, 105, 21)
$Button6 = GUICtrlCreateButton("Save", 480, 168, 121, 25)
$Button7 = GUICtrlCreateButton("Cancel", 480, 200, 121, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Button1 = GUICtrlCreateButton("+", 8, 240, 41, 25)
$Button2 = GUICtrlCreateButton("++", 56, 240, 41, 25)
$Button3 = GUICtrlCreateButton("Up", 152, 240, 49, 25)
$Button4 = GUICtrlCreateButton("Down", 208, 240, 49, 25)
$Group2 = GUICtrlCreateGroup("Global settings:", 8, 272, 601, 81)
$Label3 = GUICtrlCreateLabel("Hotkey to start:", 18, 296, 76, 17)
$Input2 = GUICtrlCreateInput("", 16, 320, 105, 21)
$Label4 = GUICtrlCreateLabel("Hotkey to pause:", 130, 296, 85, 17)
$Input3 = GUICtrlCreateInput("", 128, 320, 105, 21)
$Label6 = GUICtrlCreateLabel("Hotkey to stop:", 242, 296, 76, 17)
$Input5 = GUICtrlCreateInput("", 240, 320, 105, 21)
$Label7 = GUICtrlCreateLabel("Default delay:", 354, 296, 69, 17)
$Input6 = GUICtrlCreateInput("200", 352, 320, 105, 21)
$updown3 = GUICtrlCreateUpdown($Input6, 0xA4)
GUICtrlSetLimit($updown3, 32767, 0)
$Button10 = GUICtrlCreateButton("Save", 464, 288, 137, 25)
$Button11 = GUICtrlCreateButton("Cancel", 464, 320, 137, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Button5 = GUICtrlCreateButton("-", 104, 240, 41, 25)
$Button8 = GUICtrlCreateButton("About", 544, 240, 65, 25)
$Button9 = GUICtrlCreateButton("Hotkey help", 440, 240, 97, 25)
$Button12 = GUICtrlCreateButton("Save all", 264, 240, 81, 25)
$Button13 = GUICtrlCreateButton("Hide to tray", 352, 240, 81, 25)
readsettings()
loadactioninfo()
Opt("TrayMenuMode", 1)
Opt("TrayOnEventMode", 1)
TraySetOnEvent(-7, "toggle")
TrayItemSetOnEvent(TrayCreateItem("Toggle main window"), "toggle")
TrayCreateItem("")
TrayItemSetOnEvent(TrayCreateItem("Start"), "start")
TrayItemSetOnEvent(TrayCreateItem("Pause"), "pause")
TrayItemSetOnEvent(TrayCreateItem("Stop"), "stop")
TrayCreateItem("")
TrayItemSetOnEvent(TrayCreateItem("Exit"), "close")
TraySetClick(16)
traysetstate()
onautoitexitregister("writesettings")
if $hidden=1 then GUISetState(@SW_SHOW)

While 1
$msg = GUIGetMsg()
if $msg=-3 then
exit
elseif $msg=$button1 then;add
if $empty=false then redim $actions[ubound($actions)+1][6]
$empty=false
$actions[ubound($actions)-1][0]=1
$actions[ubound($actions)-1][3]=1
$actions[ubound($actions)-1][4]=$delay
$actions[ubound($actions)-1][5]=2
showactions()
elseif $msg=$button2 then;dupe
if $empty=false then redim $actions[ubound($actions)+1][6]
$empty=false
$temp=guictrlread($list1)
$temp=int(stringleft($temp,stringinstr($temp,".")))-1
$actions[ubound($actions)-1][0]=$actions[$temp][0]
$actions[ubound($actions)-1][1]=$actions[$temp][1]
$actions[ubound($actions)-1][2]=$actions[$temp][2]
$actions[ubound($actions)-1][3]=$actions[$temp][3]
$actions[ubound($actions)-1][4]=$actions[$temp][4]
$actions[ubound($actions)-1][5]=$actions[$temp][5]
showactions()
elseif $msg=$button3 and $empty=false then;up
$temp=guictrlread($list1)
$temp=int(stringleft($temp,stringinstr($temp,".")))-2
if $temp>=0 then
dim $temp2[6]=[$actions[$temp][0],$actions[$temp][1],$actions[$temp][2],$actions[$temp][3],$actions[$temp][4],$actions[$temp][5]]
$actions[$temp][0]=$actions[$temp+1][0]
$actions[$temp][1]=$actions[$temp+1][1]
$actions[$temp][2]=$actions[$temp+1][2]
$actions[$temp][3]=$actions[$temp+1][3]
$actions[$temp][4]=$actions[$temp+1][4]
$actions[$temp][5]=$actions[$temp+1][5]
$actions[$temp+1][0]=$temp2[0]
$actions[$temp+1][1]=$temp2[1]
$actions[$temp+1][2]=$temp2[2]
$actions[$temp+1][3]=$temp2[3]
$actions[$temp+1][4]=$temp2[4]
$actions[$temp+1][5]=$temp2[5]
showactions($temp)
endif
elseif $msg=$button4 and $empty=false then;down
$temp=guictrlread($list1)
$temp=int(stringleft($temp,stringinstr($temp,".")))
if $temp<ubound($actions) then
dim $temp2[6]=[$actions[$temp][0],$actions[$temp][1],$actions[$temp][2],$actions[$temp][3],$actions[$temp][4],$actions[$temp][5]]
$actions[$temp][0]=$actions[$temp-1][0]
$actions[$temp][1]=$actions[$temp-1][1]
$actions[$temp][2]=$actions[$temp-1][2]
$actions[$temp][3]=$actions[$temp-1][3]
$actions[$temp][4]=$actions[$temp-1][4]
$actions[$temp][5]=$actions[$temp-1][5]
$actions[$temp-1][0]=$temp2[0]
$actions[$temp-1][1]=$temp2[1]
$actions[$temp-1][2]=$temp2[2]
$actions[$temp-1][3]=$temp2[3]
$actions[$temp-1][4]=$temp2[4]
$actions[$temp-1][5]=$temp2[5]
showactions($temp)
endif
elseif $msg=$list1 or $msg=$button7 then
loadactioninfo()
elseif $msg=$button6 then
saveactioninfo()
elseif $msg=$radio1 or $msg=$radio2 then
if guictrlread($radio1)=1 then
guictrlsetstate($input4,128)
else
guictrlsetstate($input4,64)
endif
elseif $msg=$button10 then
$hotkeys[0]=guictrlread($input2)
$hotkeys[1]=guictrlread($input3)
$hotkeys[2]=guictrlread($input5)
$delay=int(guictrlread($input6))
sethotkeys()
elseif $msg=$button5 and $empty=false then;remove
$temp=guictrlread($list1)
$temp=int(stringleft($temp,stringinstr($temp,".")))-1
for $a=$temp to ubound($actions)-2
$actions[$a][0]=$actions[$a+1][0]
$actions[$a][1]=$actions[$a+1][1]
$actions[$a][2]=$actions[$a+1][2]
$actions[$a][3]=$actions[$a+1][3]
$actions[$a][4]=$actions[$a+1][4]
$actions[$a][5]=$actions[$a+1][5]
next
if ubound($actions)<=1 then
$empty=true
$actions[0][0]=""
$actions[0][1]=""
$actions[0][2]=""
$actions[0][3]=""
$actions[0][4]=""
$actions[0][5]=""
else
redim $actions[ubound($actions)-1][6]
endif
showactions($temp)
elseif $msg=$button13 then
toggle()
elseif $msg=$button12 then
writesettings()
elseif $msg=$button8 then
MsgBox(64, "About and Help", $ver & @LF & "By:  Eric Hbert" & @LF & @LF & "Download more free software at:" & @LF & "http://sites.google.com/site/calcfreak89/", 0, $form1)
elseif $msg=$button9 then
MsgBox(64, "Hotkey Help", "", 0, $form1)
endif
WEnd

func showactions($param=-1)
if $empty=false then
if $param<0 then $param=ubound($actions)-1
$temp="|"
$selection=""
$d=string(ubound($actions))
if $param>ubound($actions)-1 then $param=ubound($actions)-1
for $a=0 to ubound($actions)-1
$c=string($a+1)
For $b = 1 To StringLen($d)
	If StringLen($c) < StringLen($d) Then
		$c = "0" & $c
	Else
		ExitLoop
	EndIf
Next
$temp&=$c&".  "&$actions[$a][2]&"|"
if $a=$param then $selection=$c&".  "&$actions[$a][2]
next
$temp=stringtrimright($temp,1)
guictrlsetdata($list1,$temp,$selection)
loadactioninfo($param)
else
guictrlsetdata($list1,"")
loadactioninfo()
endif
$temp=""
endfunc

func loadactioninfo($param=-1)
if $param<0 then
$param=guictrlread($list1)
$param=int(stringleft($param,stringinstr($param,".")))-1
endif
if $empty then
if $justdisabled=false then
guictrlsetstate($group1,128)
guictrlsetstate($label2,128)
guictrlsetstate($checkbox1,128)
guictrlsetstate($label5,128)
guictrlsetstate($label8,128)
guictrlsetstate($button6,128)
guictrlsetstate($button7,128)
guictrlsetstate($input7,128)
guictrlsetstate($input8,128)
guictrlsetstate($input1,128)
guictrlsetstate($radio1,128)
guictrlsetstate($radio2,128)
guictrlsetstate($input4,128)
endif
$justdisabled=true
else
if $justdisabled=true then
guictrlsetstate($group1,64)
guictrlsetstate($label2,64)
guictrlsetstate($checkbox1,64)
guictrlsetstate($label5,64)
guictrlsetstate($label8,64)
guictrlsetstate($button6,64)
guictrlsetstate($button7,64)
guictrlsetstate($input7,64)
guictrlsetstate($input8,64)
guictrlsetstate($input1,64)
guictrlsetstate($radio1,64)
guictrlsetstate($radio2,64)
guictrlsetstate($input4,64)
endif
$justdisabled=false
guictrlsetdata($input7,$actions[$param][0])
guictrlsetdata($input8,$actions[$param][1])
guictrlsetdata($input1,$actions[$param][2])
if $actions[$param][3]=2 then
guictrlsetstate($radio2,1)
guictrlsetdata($input4,$actions[$param][4])
guictrlsetstate($input4,64)
else
guictrlsetstate($radio1,1)
guictrlsetdata($input4,$delay)
guictrlsetstate($input4,128)
endif
if $actions[$param][5]=2 then
guictrlsetstate($Checkbox1,1)
else
guictrlsetstate($Checkbox1,4)
endif
endif
endfunc

func saveactioninfo($param=-1)
if $param<0 then
$param=guictrlread($list1)
$param=int(stringleft($param,stringinstr($param,".")))-1
endif
$actions[$param][0]=guictrlread($input7)
$actions[$param][1]=guictrlread($input8)
$actions[$param][2]=guictrlread($input1)
if guictrlread($radio1)=1 then
$actions[$param][3]=1
else
$actions[$param][3]=2
endif
$actions[$param][4]=guictrlread($input4)
if guictrlread($Checkbox1)=1 then
$actions[$param][5]=2
else
$actions[$param][5]=1
endif
showactions($param)
endfunc

func start()
if $running then return
$pause=false
$stop=false
$running=true
for $a=0 to ubound($actions)-1
for $b=1 to $actions[$a][0]
if $actions[$a][3]=2 then
sleep($actions[$a][4])
else
sleep($delay)
endif
send($actions[$a][2])
if $actions[$a][5]=2 then send("{ENTER}")
if $pause then
while $pause
sleep(100)
if $stop then exitloop 3
wend
endif
if $stop then exitloop 2
next
next
$running=false
endfunc

func pause()
if $running then
$pause=not $pause
else
$pause=false
endif
endfunc

func stop()
if $running then
$stop=true
else
$stop=false
endif
endfunc

func writesettings()
$temp=$hotkeys[0]&"|"&$hotkeys[1]&"|"&$hotkeys[2]&"|"&$delay&"|"&$hidden&@lf
if not $empty then
for $a=0 to ubound($actions)-1
$temp&=$actions[$a][0]&"|"&$actions[$a][1]&"|"&$actions[$a][2]&"|"&$actions[$a][3]&"|"&$actions[$a][4]&"|"&$actions[$a][5]&@lf
next
endif
if stringright($temp,1)=@lf then $temp=stringtrimright($temp,1)
$h=fileopen("Auto-Typer.db",2)
filewrite($h,$temp)
fileclose($h)
endfunc

func readsettings()
if fileexists("Auto-Typer.db") then
$h=fileopen("Auto-Typer.db",0)
$temp=fileread($h)
fileclose($h)
$temp2=stringinstr($temp,@lf)
if $temp2=0 then
$temp3=$temp
$empty=true
else
$temp3=stringleft($temp,$temp2)
$temp=stringtrimleft($temp,$temp2)
$empty=false
endif
$temp3=stringsplit($temp3,"|",3)
redim $temp3[5]
$delay=int($temp3[3])
$hidden=int($temp3[4])
redim $temp3[3]
$hotkeys=$temp3
if not $empty then
$temp=stringsplit($temp,@lf,3)
dim $actions[ubound($temp)][6]
for $a=0 to ubound($temp)-1
$temp3=stringsplit($temp[$a],"|",3)
redim $temp3[6]
$actions[$a][0]=int($temp3[0])
$actions[$a][1]=$temp3[1]
$actions[$a][2]=$temp3[2]
$actions[$a][3]=int($temp3[3])
$actions[$a][4]=int($temp3[4])
$actions[$a][5]=int($temp3[5])
next
endif
else
$empty=true
endif
showactions()
sethotkeys()
guictrlsetdata($input2,$hotkeys[0])
guictrlsetdata($input3,$hotkeys[1])
guictrlsetdata($input5,$hotkeys[2])
guictrlsetdata($input6,$delay)
endfunc

func sethotkeys()
if $hotkeys[0]<>$oldhotkeys[0] then
hotkeyset($oldhotkeys[0])
hotkeyset($hotkeys[0],"start")
$oldhotkeys[0]=$hotkeys[0]
endif
if $hotkeys[1]<>$oldhotkeys[1] then
hotkeyset($oldhotkeys[1])
hotkeyset($hotkeys[1],"pause")
$oldhotkeys[1]=$hotkeys[1]
endif
if $hotkeys[2]<>$oldhotkeys[2] then
hotkeyset($oldhotkeys[2])
hotkeyset($hotkeys[2],"stop")
$oldhotkeys[2]=$hotkeys[2]
endif
endfunc

func toggle()
if $hidden=2 then
$hidden=1
GUISetState(@SW_SHOW)
else
$hidden=2
GUISetState(@SW_HIDE)
endif
endfunc

func close()
exit
endfunc