#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_outfile=FFEP.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Free File Encryption Program
#AutoIt3Wrapper_Res_Fileversion=3.1.0.8
#AutoIt3Wrapper_Res_Language=1033
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

Dim $gui = 0, $firstrun = 1
If $CmdLine[0] = 0 Then $gui = 1
While 1
	Dim $version = "3.1.0.8", $gtemp1 = 0, $gtemp2 = 0, $gtemp3 = "", $file = "", $file2 = "", $q[2] = [0, 0], $err2 = 0, $test1 = "", $test2 = "", $test3 = "", $test4 = "", $close = 0, $Form1 = 0, $Form2 = 0, $same = 0, $err[5] = ["Unknown error.", "You must specify at least 3 parameters.", "The input file is invalid.", "The mode must be 1, 2, or 3." & @LF & @LF & "1 = Encrypt" & @LF & "2 = Decrypt" & @LF & "3 = Test", "The password is invalid."], $canceled = 0, $main = 0, $err3 = 0, $delete = 0, $delete2 = 0
	If $firstrun = 1 Then
		Dim $cc = 0, $params[6] = [5, 1, "", "", "", 65536], $chunksize = 65536
	Else
		ReDim $params[6]
	EndIf
	If $CmdLine[0] = 0 Then
		GUIDelete($Form2)
		Opt("GUIOnEventMode", 0)
		$Form1 = GUICreate("FFEP v" & $version, 385, 257, -1, -1, -1, BitOR($WS_EX_ACCEPTFILES, $WS_EX_WINDOWEDGE))
		$Input1 = GUICtrlCreateInput("", 8, 28, 257, 21, BitOR($ES_LEFT, $ES_AUTOHSCROLL))
		GUICtrlSetState(-1, $GUI_DROPACCEPTED)
		$Button1 = GUICtrlCreateButton("Open...", 272, 27, 105, 23, 0)
		$Input2 = GUICtrlCreateInput("", 8, 78, 257, 21, BitOR($ES_LEFT, $ES_AUTOHSCROLL))
		GUICtrlSetState(-1, $GUI_DROPACCEPTED)
		$Button2 = GUICtrlCreateButton("Save as...", 272, 77, 105, 23, 0)
		$Label1 = GUICtrlCreateLabel("Input file:", 10, 8, 47, 17)
		$Label2 = GUICtrlCreateLabel("Output file:", 10, 58, 55, 17)
		$Label3 = GUICtrlCreateLabel("Password:", 10, 108, 53, 17)
		$Input4 = GUICtrlCreateInput("", 8, 128, 181, 21, BitOR($ES_PASSWORD, $ES_AUTOHSCROLL))
		GUICtrlSetLimit($Input4, 255)
		$Label4 = GUICtrlCreateLabel("Retype password:", 198, 108, 89, 17)
		$Input5 = GUICtrlCreateInput("", 196, 128, 180, 21, BitOR($ES_PASSWORD, $ES_AUTOHSCROLL))
		GUICtrlSetLimit($Input5, 255)
		$Checkbox1 = GUICtrlCreateCheckbox("Custom chunk size", 9, 156, 121, 25)
		$Input3 = GUICtrlCreateInput(65536, 8, 188, 97, 21)
		GUICtrlSetState(-1, $GUI_DISABLE)
		$Button3 = GUICtrlCreateButton("+", 105, 184, 25, 15, 0)
		GUICtrlSetState(-1, $GUI_DISABLE)
		$Button4 = GUICtrlCreateButton("-", 105, 198, 25, 15, 0)
		GUICtrlSetState(-1, $GUI_DISABLE)
		$Button5 = GUICtrlCreateButton("About", 8, 224, 57, 25, 0)
		$Button6 = GUICtrlCreateButton("Help", 72, 224, 57, 25, 0)
		$Group1 = GUICtrlCreateGroup("What to do:", 140, 160, 81, 89)
		$Radio1 = GUICtrlCreateRadio("Encrypt", 150, 176, 65, 17)
		GUICtrlSetState(-1, $GUI_CHECKED)
		$Radio2 = GUICtrlCreateRadio("Decrypt", 150, 200, 65, 17)
		$Radio3 = GUICtrlCreateRadio("Test", 150, 224, 65, 17)
		GUICtrlCreateGroup("", -99, -99, 1, 1)
		$Button8 = GUICtrlCreateButton("Reset all settings", 232, 160, 145, 25, 0)
		$Button7 = GUICtrlCreateButton("Encrypt", 232, 194, 145, 55, 1)
		GUICtrlSetFont(-1, 18, 400, 0, "Arial")
		If $firstrun = 0 Then
			If $cc = 1 And $params[1] <> 3 Then
				GUICtrlSetData($Input3, $chunksize)
				GUICtrlSetState($Checkbox1, $GUI_CHECKED)
				GUICtrlSetState($Input3, $GUI_ENABLE)
				GUICtrlSetState($Button3, $GUI_ENABLE)
				GUICtrlSetState($Button4, $GUI_ENABLE)
			Else
				GUICtrlSetData($Input3, 65536)
				GUICtrlSetState($Checkbox1, $GUI_UNCHECKED)
				GUICtrlSetState($Input3, $GUI_DISABLE)
				GUICtrlSetState($Button3, $GUI_DISABLE)
				GUICtrlSetState($Button4, $GUI_DISABLE)
			EndIf
			If $params[1] = 1 Then
				GUICtrlSetState($Radio1, $GUI_CHECKED)
			ElseIf $params[1] = 2 Then
				GUICtrlSetState($Radio2, $GUI_CHECKED)
			ElseIf $params[1] = 3 Then
				GUICtrlSetState($Radio3, $GUI_CHECKED)
			EndIf
			If StringRight($params[4], 4) = ".tmp" And $params[3] = StringTrimRight($params[4], 4) Then $params[4] = StringTrimRight($params[4], 4)
			$file = $params[3]
			$file2 = $params[4]
			GUICtrlSetData($Input1, $file)
			GUICtrlSetData($Input2, $file2)
			radio()
		EndIf
		$firstrun = 0
		GUISetState(@SW_SHOW)

		While 1
			If $main = 1 Then
				$main = 0
				If GUICtrlRead($Radio1) = 1 Then
					If GUICtrlRead($Button7) <> "Encrypt" Then GUICtrlSetData($Button7, "Encrypt")
				ElseIf GUICtrlRead($Radio2) = 1 Then
					If GUICtrlRead($Button7) <> "Decrypt" Then GUICtrlSetData($Button7, "Decrypt")
				ElseIf GUICtrlRead($Radio3) = 1 Then
					If GUICtrlRead($Button7) <> "Test" Then GUICtrlSetData($Button7, "Test")
				EndIf
				GUICtrlSetState($Button7, $GUI_ENABLE)
			EndIf
			$nMsg = GUIGetMsg()
			Switch $nMsg
				Case -3
					Exit
				Case $Button5
					MsgBox(64, "About", "FFEP v" & $version & @LF & "(Free File Encryption Program)" & @LF & "By:  Eric Hbert" & @LF & @LF & "Download more free software at:" & @LF & "http://sites.google.com/site/calcfreak89", 0, $Form1)
				Case $Button6
					MsgBox(64, "Help", "Parameters:  Mode Password Infile [Outfile [Chunk size]]" & @LF & "1. Mode:  1=Encrypt, 2=Decrypt, 3=Test" & @LF & "2. Password:  The password to use for encrypting/decrypting/testing" & @LF & "3. Infile:  The path of the input file" & @LF & "4. Outfile:  The path of the output file (default is infile.ffe)" & @LF & "5. Chunk size:  Number of bytes per chunk (default is 65536)", 0, $Form1)
				Case $Button1
					If $file = "" Or (Not FileExists($file)) Then
						If GUICtrlRead($Radio1) = 1 Then
							$gtemp1 = FileOpenDialog("Open", @ScriptDir, "All files (*.*)", 3, "", $Form1)
						Else
							$gtemp1 = FileOpenDialog("Open", @ScriptDir, "FFEP files (*.ffe)|All files (*.*)", 3, "", $Form1)
						EndIf
						If FileExists($gtemp1) Then
							$file = $gtemp1
							GUICtrlSetData($Input1, $file)
						EndIf
					Else
						If GUICtrlRead($Radio1) = 1 Then
							$gtemp1 = FileOpenDialog("Open", $file, "All files (*.*)", 3, $file, $Form1)
						Else
							$gtemp1 = FileOpenDialog("Open", $file, "FFEP files (*.ffe)|All files (*.*)", 3, $file, $Form1)
						EndIf
						If FileExists($gtemp1) Then
							$file = $gtemp1
							GUICtrlSetData($Input1, $file)
						EndIf
					EndIf
					GUICtrlSetState($Input1, $GUI_FOCUS)
				Case $Button2
					$gtemp2 = StringLeft($file2, StringInStr($file2, "\", 1, -1))
					If $file2 = "" Or (Not FileExists($gtemp2)) Then
						If $file <> "" And StringRight($file, 4) <> ".ffe" And StringRight($file, 1) <> "\" Then
							If GUICtrlRead($Radio1) = 1 Then
								If FileExists($file) Then
									$gtemp1 = FileSaveDialog("Save as", $file, "FFEP file (*.ffe)", 2, $file & ".ffe", $Form1)
								Else
									$gtemp1 = FileSaveDialog("Save as", @ScriptDir, "FFEP file (*.ffe)", 2, "", $Form1)
								EndIf
							Else
								If FileExists($file) Then
									$gtemp3 = $file
									If StringRight($gtemp3, 4) = ".ffe" Then $gtemp3 = StringTrimRight($gtemp3, 4)
									$gtemp1 = FileSaveDialog("Save as", $file, "File (*.*)", 2, $gtemp3, $Form1)
								Else
									$gtemp1 = FileSaveDialog("Save as", @ScriptDir, "File (*.*)", 2, "", $Form1)
								EndIf
							EndIf
						Else
							If GUICtrlRead($Radio1) = 1 Then
								If FileExists($file) Then
									$gtemp1 = FileSaveDialog("Save as", $file, "FFEP file (*.ffe)", 2, $file, $Form1)
								Else
									$gtemp1 = FileSaveDialog("Save as", @ScriptDir, "FFEP file (*.ffe)", 2, "", $Form1)
								EndIf
							Else
								If FileExists($file) Then
									$gtemp3 = $file
									If StringRight($gtemp3, 4) = ".ffe" Then $gtemp3 = StringTrimRight($gtemp3, 4)
									$gtemp1 = FileSaveDialog("Save as", $file, "File (*.*)", 2, $gtemp3, $Form1)
								Else
									$gtemp1 = FileSaveDialog("Save as", @ScriptDir, "File (*.*)", 2, "", $Form1)
								EndIf
							EndIf
						EndIf
						If $gtemp1 <> "" Then
							$file2 = $gtemp1
							GUICtrlSetData($Input2, $file2)
						EndIf
					Else
						If GUICtrlRead($Radio1) = 1 Then
							$gtemp1 = FileSaveDialog("Save as", $file2, "FFEP file (*.ffe)", 2, $file2, $Form1)
						Else
							$gtemp1 = FileSaveDialog("Save as", $file2, "File (*.*)", 2, $file2, $Form1)
						EndIf
						If $gtemp1 <> "" Then
							$file2 = $gtemp1
							GUICtrlSetData($Input2, $file2)
						EndIf
					EndIf
					GUICtrlSetState($Input2, $GUI_FOCUS)
				Case $Checkbox1
					If GUICtrlRead($Checkbox1) = 1 Then
						$cc = 1
						GUICtrlSetState($Input3, $GUI_ENABLE)
						GUICtrlSetState($Button3, $GUI_ENABLE)
						GUICtrlSetState($Button4, $GUI_ENABLE)
					Else
						$cc = 0
						GUICtrlSetData($Input3, 65536)
						GUICtrlSetState($Input3, $GUI_DISABLE)
						GUICtrlSetState($Button3, $GUI_DISABLE)
						GUICtrlSetState($Button4, $GUI_DISABLE)
					EndIf
				Case $Input1
					$file = GUICtrlRead($Input1)
				Case $Input2
					$file2 = GUICtrlRead($Input2)
				Case $Input3
					$gtemp1 = Int(Number(GUICtrlRead($Input3)))
					If $gtemp1 < 32 Then $gtemp1 = 32
					If Not (GUICtrlRead($Input3) == $gtemp1) Then GUICtrlSetData($Input3, $gtemp1)
				Case $Button3
					If GUICtrlRead($Checkbox1) = 1 Then
						$gtemp1 = Int(Number(GUICtrlRead($Input3))) * 2
						If $gtemp1 < 32 Then $gtemp1 = 32
						If Not (GUICtrlRead($Input3) == $gtemp1) Then GUICtrlSetData($Input3, $gtemp1)
					EndIf
				Case $Button4
					If GUICtrlRead($Checkbox1) = 1 Then
						$gtemp1 = Round(Int(Number(GUICtrlRead($Input3))) / 2, 0)
						If $gtemp1 < 32 Then $gtemp1 = 32
						If Not (GUICtrlRead($Input3) == $gtemp1) Then GUICtrlSetData($Input3, $gtemp1)
					EndIf
				Case $Radio1
					radio()
				Case $Radio2
					radio()
				Case $Radio3
					radio()
				Case $Button8
					If MsgBox(308, "WARNING!", "Are you sure you want to reset all of your settings?", 0, $Form1) = 6 Then reset()
				Case $Button7
					GUICtrlSetState($Button7, $GUI_DISABLE)
					GUICtrlSetData($Button7, "Loading...")
					$main = 1
					$params[0] = 5
					If GUICtrlRead($Radio1) = 1 Then
						$params[1] = 1
					ElseIf GUICtrlRead($Radio2) = 1 Then
						$params[1] = 2
					ElseIf GUICtrlRead($Radio3) = 1 Then
						$params[1] = 3
					EndIf
					If (GUICtrlRead($Radio1) = 1 And GUICtrlRead($Input4) == GUICtrlRead($Input5)) Or (GUICtrlRead($Radio1) <> 1) Then
						If (GUICtrlRead($Radio1) = 1 And GUICtrlRead($Input4) <> "" And GUICtrlRead($Input5) <> "") Or (GUICtrlRead($Radio1) <> 1 And GUICtrlRead($Input4) <> "") Then
							$params[2] = GUICtrlRead($Input4)
							$params[3] = GUICtrlRead($Input1)
							If FileExists($params[3]) Then
								$params[4] = GUICtrlRead($Input2)
								If $params[1] = 1 And ($params[4] = -1 Or $params[4] = "") Then $params[4] = $params[3] & ".ffe"
								If ($params[1] = 2 Or $params[1] = 3) And ($params[4] = -1 Or $params[4] = "") And StringRight($params[3], 4) = ".ffe" Then $params[4] = StringTrimRight($params[3], 4)
								If $params[1] = 3 And $params[4] = -1 Then $params[4] = ""
								$params[5] = Int(GUICtrlRead($Input3))
								$chunksize = $params[5]
								$q[0] = 0
								$q[1] = 0
								If $params[3] = $params[4] Then
									$params[4] &= ".tmp"
									$same = 1
								EndIf
								If $params[1] = 1 And StringLen($params[2]) < 4 Then
									If MsgBox(308, "Security warning", "The password is less than 4 characters!  Are you sure you want to continue?", 0, $Form1) = 6 Then $q[0] = 1
								Else
									$q[0] = 1
								EndIf
								If $q[0] = 1 And $params[1] <> 3 And FileExists($params[4]) Then
									If MsgBox(308, "Overwrite file", "Are you sure you want to overwrite this file?" & @LF & $params[4], 0, $Form1) = 6 Then $q[1] = 1
								ElseIf $q[0] = 1 And $params[1] <> 3 And Not FileExists($params[4]) Then
									$q[1] = 1
								ElseIf $q[0] = 1 And $params[1] = 3 Then
									$q[1] = 1
								EndIf
								If $q[0] = 1 And $q[1] = 1 Then ExitLoop
							Else
								MsgBox(16, "ERROR", "The input file does not exist.", 0, $Form1)
							EndIf
						Else
							If GUICtrlRead($Radio1) = 1 Then
								MsgBox(16, "ERROR", "Please type and retype a password.", 0, $Form1)
							Else
								MsgBox(16, "ERROR", "Please type a password.", 0, $Form1)
							EndIf
						EndIf
					Else
						MsgBox(16, "ERROR", "The passwords do not match.", 0, $Form1)
					EndIf
			EndSwitch
		WEnd
	Else
		$params = $CmdLine
		ReDim $params[6]
		If $params[0] < 4 Then $params[4] = -1
		If $params[0] < 5 Then $params[5] = -1
	EndIf
	If $params[0] < 3 Then error(1)
	If Not FileExists($params[3]) Then error(2)
	If $params[1] <> 1 And $params[1] <> 2 And $params[1] <> 3 Then error(3)
	If StringLen($params[2]) > 255 Then $params[2] = StringLeft($params[2], 255)
	If $params[2] = "" Then error(4)
	If $params[1] = 1 And ($params[4] = -1 Or $params[4] = "") Then $params[4] = $params[3] & ".ffe"
	If ($params[1] = 2 Or $params[1] = 3) And ($params[4] = -1 Or $params[4] = "") And StringRight($params[3], 4) = ".ffe" Then $params[4] = StringTrimRight($params[3], 4)
	If $params[4] = "" Or $params[4] = -1 Then $params[4] = $params[3]
	If $params[1] = 3 And $params[4] = -1 Then $params[4] = ""
	$params[5] = Int(Number($params[5]))
	If $params[5] = -1 Then $params[5] = 65536
	If $params[5] < 32 Then $params[5] = 32
	If $gui = 0 Then
		If $params[3] = $params[4] Then
			$params[4] &= ".tmp"
			$same = 1
		EndIf
		If $params[1] = 1 And StringLen($params[2]) < 4 And MsgBox(308, "Security warning", "The password is less than 4 characters!  Are you sure you want to continue?") <> 6 Then Exit
		If $params[1] <> 3 And FileExists($params[4]) And MsgBox(308, "Overwrite file", "Are you sure you want to overwrite this file?" & @LF & $params[4]) <> 6 Then Exit
	EndIf
	Dim $gui2 = "", $gui2b = ""
	If $params[1] = 1 Then
		$gui2 = "Encrypting password..."
		$gui2b = "Encrypting..."
	ElseIf $params[1] = 2 Then
		$gui2 = "Testing..."
		$gui2b = "Decrypting..."
	ElseIf $params[1] = 3 Then
		$gui2 = "Testing..."
		$gui2b = "Testing..."
	EndIf
	GUIDelete($Form1)
	Opt("GUIOnEventMode", 1)
	$Form2 = GUICreate("FFEP v" & $version & " - " & $gui2b, 393, 241, -1, -1)
	$Label1 = GUICtrlCreateLabel($gui2, 8, 8, 379, 36, $SS_CENTER)
	GUICtrlSetFont(-1, 20, 400, 0, "Arial")
	$Progress1 = GUICtrlCreateProgress(9, 72, 376, 25)
	$Label2 = GUICtrlCreateLabel("Total progress:", 10, 54, 74, 17)
	$Label3 = GUICtrlCreateLabel("0%", 319, 54, 62, 17, $SS_RIGHT)
	$Label4 = GUICtrlCreateLabel("Chunks processed:  0/?", 10, 110, 269, 17)
	$Label5 = GUICtrlCreateLabel("", 10, 158, 269, 17)
	$Label6 = GUICtrlCreateLabel("Bytes processed:  0/?", 10, 134, 269, 17)
	$Button1 = GUICtrlCreateButton("Cancel", 288, 144, 98, 25, 0)
	$Button2 = GUICtrlCreateButton("Pause", 288, 112, 98, 25, 1)
	$Label7 = GUICtrlCreateLabel("Input file:", 10, 186, 55, 17)
	$Label8 = GUICtrlCreateLabel("Output file:", 10, 214, 55, 17)
	$Input1 = GUICtrlCreateInput($params[3], 72, 184, 313, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
	$Input2 = GUICtrlCreateInput($params[4], 72, 212, 313, 21, BitOR($ES_AUTOHSCROLL, $ES_READONLY))
	If $params[1] = 3 Then
		GUICtrlSetState($Label8, $GUI_DISABLE)
		GUICtrlSetState($Input2, $GUI_DISABLE)
		GUICtrlSetState($Label4, $GUI_DISABLE)
		GUICtrlSetState($Label5, $GUI_DISABLE)
		GUICtrlSetState($Label6, $GUI_DISABLE)
	Else
		GUICtrlSetOnEvent($Button1, "cancel")
		GUICtrlSetOnEvent($Button2, "pause")
		GUISetOnEvent($GUI_EVENT_CLOSE, "cancel")
	EndIf
	GUICtrlSetState($Button2, $GUI_FOCUS)
	Dim $a, $b, $c, $d = 0, $e, $f, $l = 0, $n = 0, $out = "", $tc = 0, $tb = 0, $handle, $handle2, $outpass = "", $temp = "", $temp2 = "", $tc2 = "", $tb2 = "", $timer
	; $tc=total chunks, $tb=total bytes
	; Encrypt
	If $params[1] = 1 Then
		$tb = FileGetSize($params[3])
		If $params[5] > $tb Then $params[5] = $tb
		GUICtrlSetData($Label5, "Chunk size:  " & GroupDigits(String($params[5])))
		GUISetState(@SW_SHOW)
		$tc = Ceiling($tb / $params[5])
		If $tb = 0 Then $tc = 0
		$tb2 = GroupDigits(String($tb))
		$tc2 = GroupDigits(String($tc))
		$handle = FileOpen($params[3], 16)
		If FileExists($params[4]) Then FileDelete($params[4])
		$handle2 = FileOpen($params[4], 2)
		FileClose($handle2)
		; encrypt password
		$l = StringLen($params[2])
		For $n = 1 To $l Step 1
			$temp &= StringMid($params[2], (($l - ($n / 2)) * - (2 * (($n / 2) - Int($n / 2)) - 1)) + (Int($n / 2) * 2 * (($n / 2) - Int($n / 2))) + 1, 1)
		Next
		For $n = $l To 1 Step -1
			$outpass &= StringMid($temp, $n, 1)
		Next
		$temp = ""
		For $n = 1 To $l Step 1
			$temp = BitRotate(Asc(StringMid($params[2], $n, 1)), Asc(StringMid($outpass, $n, 1)) + StringLen($outpass), "B")
			$temp = BitXOR($temp, Asc(StringMid($outpass, $n, 1)))
			$temp = BitRotate($temp, Asc(StringMid($outpass, $n, 1)) + StringLen($outpass), "B")
			$temp2 &= Chr($temp)
		Next
		$outpass = $temp2
		$temp = ""
		$temp2 = ""
		$handle2 = FileOpen($params[4], 17)
		FileWrite($handle2, $outpass & Chr(StringLen($outpass)))
		; encrypt file
		GUICtrlSetData($Label1, $gui2b)
		GUICtrlSetData($Label6, "Bytes processed:  0/" & $tb2)
		GUICtrlSetData($Progress1, 0, 0)
		GUICtrlSetData($Label3, "0%")
		GUICtrlSetData($Label4, "Chunks processed:  0/" & $tc2)
		$timer = TimerInit()
		For $a = 1 To $tc Step 1
			If $a = $tc Then $params[5] = $tb - (($a - 1) * $params[5])
			$b = String(FileRead($handle, $params[5]))
			$out = ""
			For $c = 3 To StringLen($b) Step 2
				$d += 1
				If $d > StringLen($params[2]) Then $d = 1
				$e = BitRotate(Number("0x" & StringMid($b, $c, 2)), Asc(StringMid($params[2], $d, 1)) + StringLen($params[2]), "B")
				$e = BitXOR($e, Asc(StringMid($params[2], $d, 1)))
				$e = BitRotate($e, Asc(StringMid($params[2], $d, 1)) + StringLen($params[2]), "B")
				$out &= Chr($e)
			Next
			FileWrite($handle2, $out)
			If $a = $tc Or TimerDiff($timer) >= 500 Then
				If $a >= $tc Then
					GUICtrlSetData($Label6, "Bytes processed:  " & $tb2 & "/" & $tb2)
					GUICtrlSetData($Progress1, 100, 0)
					GUICtrlSetData($Label3, "100%")
				Else
					GUICtrlSetData($Label6, "Bytes processed:  " & GroupDigits(String($params[5] * $a)) & "/" & $tb2)
					$temp = Round((($params[5] * $a) / $tb) * 100, 0)
					If GUICtrlRead($Progress1) <> $temp Then GUICtrlSetData($Progress1, $temp)
					$temp = String(Round((($params[5] * $a) / $tb) * 100, 2)) & "%"
					If Not (GUICtrlRead($Label3) == $temp) Then GUICtrlSetData($Label3, $temp)
					$temp = ""
				EndIf
				GUICtrlSetData($Label4, "Chunks processed:  " & GroupDigits(String($a)) & "/" & $tc2)
				$timer = TimerInit()
			EndIf
			If $canceled = 1 Then
				FileClose($handle)
				FileClose($handle2)
				If $delete = 1 Then FileDelete($params[4])
				If $gui = 0 Then
					Exit
				Else
					ContinueLoop 2
				EndIf
			EndIf
		Next
		FileClose($handle)
		FileClose($handle2)
		$err3 = 1
		If $same = 1 Then
			$err3 = FileMove($params[4], $params[3], 1)
			If $err3 = 0 Then
				FileDelete($params[3])
				$err3 = FileMove($params[4], $params[3], 1)
				If $err3 = 0 Then MsgBox(16, "ERROR", "Failed to properly save the output file.", 0, $Form2)
			EndIf
		EndIf
		If $err3 = 1 Then MsgBox(64, "Completed", "The file was successfully encrypted.", 0, $Form2)
		If $gui = 0 Then Exit
		; Decrypt
	ElseIf $params[1] = 2 Then
		$tb = FileGetSize($params[3])
		If $params[5] > $tb Then $params[5] = $tb
		GUICtrlSetData($Label5, "Chunk size:  " & GroupDigits(String($params[5])))
		GUISetState(@SW_SHOW)
		If test($params[3], $params[2]) <> 1 Then
			MsgBox(16, "Password test", "The password you entered is incorrect.", 0, $Form2)
			If $gui = 1 Then
				ContinueLoop 1
			Else
				Exit
			EndIf
		EndIf
		$tc = Ceiling($tb / $params[5])
		If $tb = 0 Then $tc = 0
		$tb2 = GroupDigits(String($tb))
		$tc2 = GroupDigits(String($tc))
		$handle = FileOpen($params[3], 16)
		If FileExists($params[4]) Then FileDelete($params[4])
		$handle2 = FileOpen($params[4], 2)
		FileClose($handle2)
		$handle2 = FileOpen($params[4], 17)
		GUICtrlSetData($Label1, $gui2b)
		GUICtrlSetData($Label6, "Bytes processed:  0/" & $tb2)
		GUICtrlSetData($Progress1, 0, 0)
		GUICtrlSetData($Label3, "0%")
		GUICtrlSetData($Label4, "Chunks processed:  0/" & $tc2)
		$timer = TimerInit()
		For $a = 1 To $tc Step 1
			If $a = $tc Then $params[5] = $tb - (($a - 1) * $params[5])
			$b = String(FileRead($handle, $params[5]))
			If $a = 1 Then $b = StringLeft($b, 2) & StringTrimLeft($b, (StringLen($params[2]) * 2) + 4)
			$out = ""
			For $c = 3 To StringLen($b) Step 2
				$d += 1
				If $d > StringLen($params[2]) Then $d = 1
				$e = BitRotate(Number("0x" & StringMid($b, $c, 2)), -(Asc(StringMid($params[2], $d, 1)) + StringLen($params[2])), "B")
				$e = BitXOR($e, Asc(StringMid($params[2], $d, 1)))
				$e = BitRotate($e, -(Asc(StringMid($params[2], $d, 1)) + StringLen($params[2])), "B")
				$out &= Chr($e)
			Next
			FileWrite($handle2, $out)
			If $a = $tc Or TimerDiff($timer) >= 500 Then
				If $a >= $tc Then
					GUICtrlSetData($Label6, "Bytes processed:  " & $tb2 & "/" & $tb2)
					GUICtrlSetData($Progress1, 100, 0)
					GUICtrlSetData($Label3, "100%")
				Else
					GUICtrlSetData($Label6, "Bytes processed:  " & GroupDigits(String($params[5] * $a)) & "/" & $tb2)
					$temp = Round((($params[5] * $a) / $tb) * 100, 0)
					If GUICtrlRead($Progress1) <> $temp Then GUICtrlSetData($Progress1, $temp)
					$temp = String(Round((($params[5] * $a) / $tb) * 100, 2)) & "%"
					If Not (GUICtrlRead($Label3) == $temp) Then GUICtrlSetData($Label3, $temp)
					$temp = ""
				EndIf
				GUICtrlSetData($Label4, "Chunks processed:  " & GroupDigits(String($a)) & "/" & $tc2)
				$timer = TimerInit()
			EndIf
			If $canceled = 1 Then
				FileClose($handle)
				FileClose($handle2)
				If $delete = 1 Then FileDelete($params[4])
				If $gui = 0 Then
					Exit
				Else
					ContinueLoop 2
				EndIf
			EndIf
		Next
		FileClose($handle)
		FileClose($handle2)
		$err3 = 1
		If $same = 1 Then
			$err3 = FileMove($params[4], $params[3], 1)
			If $err3 = 0 Then
				FileDelete($params[3])
				$err3 = FileMove($params[4], $params[3], 1)
				If $err3 = 0 Then MsgBox(16, "ERROR", "Failed to properly save the output file.", 0, $Form2)
			EndIf
		EndIf
		If $err3 = 1 Then MsgBox(64, "Completed", "The file was successfully decrypted.", 0, $Form2)
		If $gui = 0 Then Exit
		; Test
	ElseIf $params[1] = 3 Then
		If $gui Then GUISetState(@SW_SHOW)
		If test($params[3], $params[2]) = 1 Then
			MsgBox(64, "Password test", "The password you entered is correct.", 0, $Form2)
		Else
			MsgBox(16, "Password test", "The password you entered is incorrect.", 0, $Form2)
		EndIf
		If $gui = 0 Then Exit
	EndIf
	If $gui = 0 And $canceled = 1 Then
		Exit
	ElseIf $gui = 1 And $canceled = 1 Then
		ContinueLoop
	EndIf
WEnd

Func test($test1, $test2)
	$handle = FileOpen($test1, 0)
	$test3 = FileRead($handle, StringLen($test2) + 1)
	FileClose($handle)
	If Not (StringRight($test3, 1) == Chr(StringLen($test2))) Then Return 0
	$test3 = StringTrimRight($test3, 1)
	$l = StringLen($test3)
	$temp = ""
	$temp2 = ""
	$outpass = ""
	For $n = 1 To $l Step 1
		$temp &= StringMid($test2, (($l - ($n / 2)) * - (2 * (($n / 2) - Int($n / 2)) - 1)) + (Int($n / 2) * 2 * (($n / 2) - Int($n / 2))) + 1, 1)
	Next
	For $n = $l To 1 Step -1
		$test4 &= StringMid($temp, $n, 1)
	Next
	$temp = ""
	For $n = 1 To $l Step 1
		$temp = BitRotate(Asc(StringMid($test3, $n, 1)), -(Asc(StringMid($test4, $n, 1)) + StringLen($test4)), "B")
		$temp = BitXOR($temp, Asc(StringMid($test4, $n, 1)))
		$temp = BitRotate($temp, -(Asc(StringMid($test4, $n, 1)) + StringLen($test4)), "B")
		$temp2 &= Chr($temp)
	Next
	$outpass = $temp2
	$temp = ""
	$temp2 = ""
	If $outpass == $test2 Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc   ;==>test

Func radio()
	If GUICtrlRead($Radio1) = 1 Then
		If GUICtrlRead($Button7) <> "Encrypt" Then GUICtrlSetData($Button7, "Encrypt")
		GUICtrlSetState($Input5, $GUI_ENABLE)
		GUICtrlSetState($Input2, $GUI_ENABLE)
		GUICtrlSetState($Button2, $GUI_ENABLE)
		GUICtrlSetState($Checkbox1, $GUI_ENABLE)
		If GUICtrlRead($Checkbox1) = 1 Then
			GUICtrlSetState($Input3, $GUI_ENABLE)
			GUICtrlSetState($Button3, $GUI_ENABLE)
			GUICtrlSetState($Button4, $GUI_ENABLE)
		Else
			GUICtrlSetState($Input3, $GUI_DISABLE)
			GUICtrlSetState($Button3, $GUI_DISABLE)
			GUICtrlSetState($Button4, $GUI_DISABLE)
		EndIf
		GUICtrlSetState($Label2, $GUI_ENABLE)
		GUICtrlSetState($Label4, $GUI_ENABLE)
	ElseIf GUICtrlRead($Radio2) = 1 Then
		If GUICtrlRead($Button7) <> "Decrypt" Then GUICtrlSetData($Button7, "Decrypt")
		GUICtrlSetState($Input5, $GUI_DISABLE)
		GUICtrlSetState($Input2, $GUI_ENABLE)
		GUICtrlSetState($Button2, $GUI_ENABLE)
		GUICtrlSetState($Checkbox1, $GUI_ENABLE)
		If GUICtrlRead($Checkbox1) = 1 Then
			GUICtrlSetState($Input3, $GUI_ENABLE)
			GUICtrlSetState($Button3, $GUI_ENABLE)
			GUICtrlSetState($Button4, $GUI_ENABLE)
		Else
			GUICtrlSetState($Input3, $GUI_DISABLE)
			GUICtrlSetState($Button3, $GUI_DISABLE)
			GUICtrlSetState($Button4, $GUI_DISABLE)
		EndIf
		GUICtrlSetState($Label2, $GUI_ENABLE)
		GUICtrlSetState($Label4, $GUI_DISABLE)
	ElseIf GUICtrlRead($Radio3) = 1 Then
		If GUICtrlRead($Button7) <> "Test" Then GUICtrlSetData($Button7, "Test")
		GUICtrlSetState($Input5, $GUI_DISABLE)
		GUICtrlSetState($Input2, $GUI_DISABLE)
		GUICtrlSetState($Button2, $GUI_DISABLE)
		GUICtrlSetState($Checkbox1, $GUI_DISABLE)
		GUICtrlSetState($Input3, $GUI_DISABLE)
		GUICtrlSetState($Button3, $GUI_DISABLE)
		GUICtrlSetState($Button4, $GUI_DISABLE)
		GUICtrlSetState($Label2, $GUI_DISABLE)
		GUICtrlSetState($Label4, $GUI_DISABLE)
	EndIf
EndFunc   ;==>radio

Func reset()
	$file = ""
	$file2 = ""
	GUICtrlSetData($Input1, "")
	GUICtrlSetData($Input2, "")
	GUICtrlSetData($Input4, "")
	GUICtrlSetData($Input5, "")
	GUICtrlSetData($Input3, 65536)
	GUICtrlSetData($Button7, "Encrypt")
	GUICtrlSetState($Input5, $GUI_ENABLE)
	GUICtrlSetState($Input2, $GUI_ENABLE)
	GUICtrlSetState($Button2, $GUI_ENABLE)
	GUICtrlSetState($Checkbox1, $GUI_UNCHECKED)
	GUICtrlSetState($Checkbox1, $GUI_ENABLE)
	GUICtrlSetState($Input3, $GUI_DISABLE)
	GUICtrlSetState($Button3, $GUI_DISABLE)
	GUICtrlSetState($Button4, $GUI_DISABLE)
	GUICtrlSetState($Label2, $GUI_ENABLE)
	GUICtrlSetState($Label4, $GUI_ENABLE)
	GUICtrlSetState($Radio1, $GUI_CHECKED)
EndFunc   ;==>reset

Func error($err2 = 0)
	MsgBox(16, "Error " & String($err2), $err[$err2])
	Exit
EndFunc   ;==>error

Func pause()
	GUICtrlSetData($Button2, "Resume")
	Opt("GUIOnEventMode", 0)
	While 1
		$nMsg = GUIGetMsg()
		If $nMsg = $Button2 Then
			GUICtrlSetData($Button2, "Pause")
			Opt("GUIOnEventMode", 1)
			ExitLoop
		EndIf
		If $nMsg = $Button1 And MsgBox(308, "WARNING", "Are you sure you want to cancel?", 0, $Form2) = 6 Then
			$canceled = 1
			$delete = 0
			If $params[1] = 1 Or $params[1] = 2 Then
				$delete2 = MsgBox(563, "Delete output file", "Do you also want to delete the output file?" & @LF & "Output filename:  " & $params[4] & @LF & @LF & "Yes = cancel & delete;  No = cancel & don't delete;" & @LF & "Cancel = don't cancel & don't delete", 0, $Form2)
				If $delete2 = 6 Then
					$delete = 1
				ElseIf $delete2 = 7 Then
					$delete = 0
				Else
					$delete = 2
				EndIf
			EndIf
			If $delete <> 2 Then
				GUICtrlSetState($Button1, $GUI_DISABLE)
				GUICtrlSetData($Button1, "Canceling...")
				GUICtrlSetData($Button2, "Pause")
				Opt("GUIOnEventMode", 1)
				ExitLoop
			EndIf
		EndIf
	WEnd
EndFunc   ;==>pause

Func cancel()
	If MsgBox(308, "WARNING", "Are you sure you want to cancel?", 0, $Form2) = 6 Then
		$canceled = 1
		$delete = 0
		If $params[1] = 1 Or $params[1] = 2 Then
			$delete2 = MsgBox(563, "Delete output file", "Do you also want to delete the output file?" & @LF & "Output filename:  " & $params[4] & @LF & @LF & "Yes = cancel & delete;  No = cancel & don't delete;" & @LF & "Cancel = don't cancel & don't delete", 0, $Form2)
			If $delete2 = 6 Then
				$delete = 1
			ElseIf $delete2 = 7 Then
				$delete = 0
			Else
				$delete = 2
				$canceled = 0
			EndIf
		EndIf
		If $canceled = 1 Then
			GUICtrlSetState($Button1, $GUI_DISABLE)
			GUICtrlSetData($Button1, "Canceling...")
		EndIf
	EndIf
EndFunc   ;==>cancel

Func GroupDigits($grpdig)
	Local $grpdig2 = 0, $grpdig3 = 0, $grpdig4 = ""
	If StringLen($grpdig) >= 4 Then
		$grpdig2 = StringLen($grpdig)
		While 1
			$grpdig2 = $grpdig2 - 3
			If $grpdig2 < 3 Then ExitLoop
		WEnd
		$grpdig4 = $grpdig4 & StringLeft($grpdig, $grpdig2) & ","
		For $grpdig3 = $grpdig2 + 1 To StringLen($grpdig) Step 3
			$grpdig4 = $grpdig4 & StringMid($grpdig, $grpdig3, 3) & ","
		Next
		If StringLeft($grpdig4, 1) = "," Then $grpdig4 = StringRight($grpdig4, StringLen($grpdig4) - 1)
		If StringRight($grpdig4, 1) = "," Then $grpdig4 = StringLeft($grpdig4, StringLen($grpdig4) - 1)
		Return $grpdig4
	Else
		Return $grpdig
	EndIf
EndFunc   ;==>GroupDigits

Exit