#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Genre Finder
#AutoIt3Wrapper_Res_Fileversion=0.1.0.2
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

Dim $ver = "Genre Finder v0.1.0.2 Beta", $a, $b, $c, $d, $e, $f, $g, $h, $handle

ClipPut(128)

$Form1 = GUICreate($ver, 369, 208, -1, -1)
$Label1 = GUICtrlCreateLabel("Artist:", 8, 8, 30, 17)
$Input1 = GUICtrlCreateInput("", 8, 32, 353, 21)
$Label2 = GUICtrlCreateLabel("Title of song (optional):", 8, 64, 111, 17)
$Input2 = GUICtrlCreateInput("", 8, 88, 353, 21)
$Button1 = GUICtrlCreateButton("Find genres from Last.fm", 8, 120, 257, 25, 1)
$Button2 = GUICtrlCreateButton("About", 272, 120, 89, 25, 0)
$Label3 = GUICtrlCreateLabel("Top five genres/tags:", 8, 154, 353, 17)
$Input3 = GUICtrlCreateInput("", 8, 178, 353, 21, 2176)
GUICtrlSetBkColor(-1, 0xFFFFFF)
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case -3
			Exit
		Case $Button1

			$a = GUICtrlRead($Input1)
			$g = GUICtrlRead($Input2)

			If $a <> "" Then

				GUICtrlSetState($Label1, 128)
				GUICtrlSetState($Input1, 128)
				GUICtrlSetState($Label2, 128)
				GUICtrlSetState($Input2, 128)
				GUICtrlSetState($Label3, 128)
				GUICtrlSetState($Input3, 128)
				GUICtrlSetState($Button2, 128)
				GUICtrlSetData($Button2, "About")
				GUICtrlSetState($Button1, 128)
				GUICtrlSetData($Button1, "Loading...")

				$h = "Top five genres/tags for " & '"' & $a
				If $g <> "" Then $h &= " - " & $g
				$h &= '":'

				$a = "http://www.last.fm/music/" & $a
				$song = 0
				If $g <> "" Then
					$a &= "/_/" & $g
					$song = 1
				EndIf

				$b = InetRead($a)
				If $b <> "" Then
					$c = BinaryToString($b)
					If $song Then
						$d = StringInStr($c, "Popular tags:")
					Else
						$d = StringInStr($c, "Tagged as:")
					EndIf
					$f = ""
					If $d Then
						For $e = 1 To 5
							If $song And $e = 1 Then
								$d = StringInStr($c, ">", 0, 1, $d)
							Else
								$d = StringInStr($c, ">", 0, 3, $d)
							EndIf
							If $d = 0 Then ExitLoop
							$f &= ",  " & String($e) & ". " & StringMid($c, $d + 1, StringInStr($c, "<", 0, 1, $d) - $d - 1)
						Next
						$f = StringTrimLeft($f, 3)
					EndIf
					$c = _StringProper($f)

					If Not (GUICtrlRead($Label3) == $h) Then GUICtrlSetData($Label3, $h)

				Else
					MsgBox(16, "ERROR", 'The link "' & $a & '" could not be downloaded.', 0, $Form1)
				EndIf

				If Not (GUICtrlRead($Input3) == $c) Then GUICtrlSetData($Input3, $c)

				GUICtrlSetState($Label1, 64)
				GUICtrlSetState($Input1, 64)
				GUICtrlSetState($Label2, 64)
				GUICtrlSetState($Input2, 64)
				GUICtrlSetState($Label3, 64)
				GUICtrlSetState($Input3, 64)
				GUICtrlSetState($Button2, 64)
				GUICtrlSetData($Button1, "Find genres from Last.fm")
				GUICtrlSetState($Button1, 64)

			EndIf

		Case $Button2
			MsgBox(64, "About", $ver & @LF & "By:  Eric Hbert" & @LF & @LF & "Download more free software at:" & @LF & "http://sites.google.com/site/calcfreak89/", 0, $Form1)
	EndSwitch
WEnd

Func _StringProper($s_String)
	Local $iX = 0
	Local $CapNext = 1
	Local $s_nStr = ""
	Local $s_CurChar
	For $iX = 1 To StringLen($s_String)
		$s_CurChar = StringMid($s_String, $iX, 1)
		Select
			Case $CapNext = 1
				If StringRegExp($s_CurChar, '[a-zA-Z-]') Then
					$s_CurChar = StringUpper($s_CurChar)
					$CapNext = 0
				EndIf
			Case Not StringRegExp($s_CurChar, '[a-zA-Z-]')
				$CapNext = 1
			Case Else
				$s_CurChar = StringLower($s_CurChar)
		EndSelect
		$s_nStr &= $s_CurChar
	Next
	Return $s_nStr
EndFunc   ;==>_StringProper