#NoTrayIcon

#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.0.0
 Author:         Eric Hbert

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

FileChangeDir(@ScriptDir)

Dim $version="2.1.5.4",$a[26]=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"],$b[26]=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"],$c[10]=["0","1","2","3","4","5","6","7","8","9"],$d[10]=["!","@","#","$","%","^","&","<",">","?"],$temp="",$temp2="",$temp3="",$temp4="",$temp5="",$temp6="",$temp7="",$temp8="",$temp9="",$temp10="",$temp11="",$temp12="",$param1="",$param2="",$param3="",$param4="",$param5="",$param6="",$param7="",$param8="",$settings[11]=[0,0,0,0,"",0,"",1,0,0,0],$password="",$smallpass="",$handle="",$alg1="This algorithm generates a completely random password and is very fast and simple.  First, it generates random characters, with the desired settings, in non-random positions.  Then, the string is scrambled the desired number of times.",$alg2="This algorithm generates a completely random password, but makes the password seem more random.  First, it generates random characters, with the desired settings, in non-random positions.  Then, it uses a special scrambling algorithm that positions the characters so that equal character types are usually not adjacent.  This will make the password look more random."&@CRLF&@CRLF&"(Note: Character types are lowercase letters, capital letters, numbers, and symbols.)"

$Form1 = GUICreate("Random Password Generator v"&$version, 562, 386, -1, -1)
$Input1 = GUICtrlCreateInput("0", 9, 64, 25, 21)
$Button4 = GUICtrlCreateButton("+", 34, 59, 31, 16, 0)
$Button5 = GUICtrlCreateButton("-", 34, 74, 31, 16, 0)
$Input2 = GUICtrlCreateInput("0", 88, 64, 25, 21)
$Button6 = GUICtrlCreateButton("+", 113, 59, 31, 16, 0)
$Button7 = GUICtrlCreateButton("-", 113, 74, 31, 16, 0)
$Input3 = GUICtrlCreateInput("0", 9, 144, 25, 21)
$Button8 = GUICtrlCreateButton("+", 34, 139, 31, 16, 0)
$Button9 = GUICtrlCreateButton("-", 34, 154, 31, 16, 0)
$Input4 = GUICtrlCreateInput("0", 88, 144, 25, 21)
$Button10 = GUICtrlCreateButton("+", 113, 139, 31, 16, 0)
$Button11 = GUICtrlCreateButton("-", 113, 154, 31, 16, 0)
$Input6 = GUICtrlCreateInput("", 8, 228, 137, 21)
$Input9 = GUICtrlCreateInput("0", 9, 289, 25, 21)
$Button13 = GUICtrlCreateButton("+", 34, 284, 31, 16, 0)
$Button14 = GUICtrlCreateButton("-", 34, 299, 31, 16, 0)
$Input8 = GUICtrlCreateInput("", 80, 288, 209, 21)
$Group1 = GUICtrlCreateGroup("Algorithm:", 160, 8, 177, 249)
$Radio1 = GUICtrlCreateRadio("Algorithm 1", 168, 24, 161, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
$Radio2 = GUICtrlCreateRadio("Algorithm 2", 168, 44, 161, 17)
$Edit1 = GUICtrlCreateEdit($alg1, 170, 70, 159, 121, $ES_READONLY+$ES_WANTRETURN+$WS_VSCROLL, 0)
$Checkbox1 = GUICtrlCreateCheckbox("Use custom # of scrambles:", 170, 200, 159, 17)
$Input7 = GUICtrlCreateInput("0", 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Button1 = GUICtrlCreateButton("Generate Password", 352, 8, 201, 59, 0)
If @OSVersion="WIN_VISTA" Then
GUICtrlSetFont($Button1, 15, 800, 0, "Calibri")
Else
GUICtrlSetFont($Button1, 13, 600, 0, "Calibri")
EndIf
$Input5 = GUICtrlCreateInput("", 353, 160, 199, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
$Button2 = GUICtrlCreateButton("Copy password to clipboard", 352, 224, 201, 41, 0)
$Button12 = GUICtrlCreateButton("Save password as a text file...", 304, 272, 249, 41, 0)
$Button17 = GUICtrlCreateButton("Default settings", 304, 320, 121, 25, 0)
$Button15 = GUICtrlCreateButton("Save settings", 432, 320, 121, 25, 0)
$Checkbox2 = GUICtrlCreateCheckbox("Save settings on exit", 306, 352, 121, 25)
$Button3 = GUICtrlCreateButton("About", 432, 352, 121, 25, 0)
$Label2 = GUICtrlCreateLabel("Lowercase", 8, 8, 56, 17, $SS_CENTER)
$Label3 = GUICtrlCreateLabel("Capital", 87, 8, 56, 17, $SS_CENTER)
$Label1 = GUICtrlCreateLabel("Numbers:", 8, 104, 56, 17, $SS_CENTER)
$Label4 = GUICtrlCreateLabel("Symbols:", 87, 104, 56, 17, $SS_CENTER)
$Label5 = GUICtrlCreateLabel("(a, b, c...)", 8, 40, 56, 17, $SS_CENTER)
$Label6 = GUICtrlCreateLabel("(A, B, C...)", 87, 40, 56, 17, $SS_CENTER)
$Label7 = GUICtrlCreateLabel("(1, 2, 3...)", 8, 120, 56, 17, $SS_CENTER)
$Label9 = GUICtrlCreateLabel("Generated password:", 354, 140, 105, 17)
$Label10 = GUICtrlCreateLabel("Custom characters 1:", 8, 188, 104, 17)
$Label8 = GUICtrlCreateLabel("letters:", 8, 24, 56, 17, $SS_CENTER)
$Label11 = GUICtrlCreateLabel("letters:", 87, 24, 56, 17, $SS_CENTER)
$Progress1 = GUICtrlCreateProgress(353, 100, 199, 25)
$Label12 = GUICtrlCreateLabel("(!, @, #...)", 87, 120, 56, 17, $SS_CENTER)
$Label13 = GUICtrlCreateLabel("Status:  Idle", 354, 80, 164, 17)
$Label23 = GUICtrlCreateLabel("(All of these will be used.)", 8, 204, 123, 17)
$Label24 = GUICtrlCreateLabel("Custom characters 2:", 8, 264, 104, 17)
$Label25 = GUICtrlCreateLabel("(The # you specify will be the # of these characters used.)", 8, 320, 278, 17)
$Label26 = GUICtrlCreateLabel("Random Password Generator v"&$version, 8, 356, 290, 23)
GUICtrlSetFont(-1, 12, 400, 0, "Calibri")
$Label15 = GUICtrlCreateLabel("0%", 520, 80, 31, 17, $SS_RIGHT)
$Label28 = GUICtrlCreateLabel("Password length: 0", 354, 195, 196, 17)
If FileExists("Settings.ini") Then
readsettings()
applysettings()
EndIf
GUISetState(@SW_SHOW)

While 1
$nMsg = GUIGetMsg()
Switch $nMsg
Case $GUI_EVENT_CLOSE
gathersettings()
If $settings[10]=1 Then writesettings()
Exit
Case $Button3
MsgBox(64,"About","Random Password Generator v"&$version&@LF&"By Eric Hbert"&@LF&@LF&"Download more free software at:"&@LF&"http://calcfreak89.webs.com/",0,$Form1)
Case $Label26
MsgBox(64,"About","Random Password Generator v"&$version&@LF&"By Eric Hbert"&@LF&@LF&"Download more free software at:"&@LF&"http://calcfreak89.webs.com/",0,$Form1)
Case $Button2
ClipPut($password)
Case $Button1
Dim $grpdig=0,$grpdig2=0,$grpdig3=0,$grpdig4=""
$temp="Password length: "&_GroupDigits (String(Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6))))
If GUICtrlRead($Label28)<>$temp Then
GUICtrlDelete($Label28)
$Label28 = GUICtrlCreateLabel($temp, 354, 195, 196, 17)
EndIf
If GUICtrlRead($Radio1)=1 Then
$password=alg1(GUICtrlRead($Input1),GUICtrlRead($Input2),GUICtrlRead($Input3),GUICtrlRead($Input4),GUICtrlRead($Input6),GUICtrlRead($Input9),GUICtrlRead($Input8),GUICtrlRead($Input7))
Else
$password=alg2(GUICtrlRead($Input1),GUICtrlRead($Input2),GUICtrlRead($Input3),GUICtrlRead($Input4),GUICtrlRead($Input6),GUICtrlRead($Input9),GUICtrlRead($Input8))
EndIf
$smallpass=""
GUICtrlSetData($Progress1,0)
If GUICtrlRead($Label15)<>"0%" Then
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel("0%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
If GUICtrlRead($Label13)<>"Status:  Idle" Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Idle", 354, 80, 164, 17)
EndIf
If StringLen($password)>5000 Then $smallpass=StringLeft($password,5000)
If $smallpass="" Then
GUICtrlSetData($Input5,$password)
Else
GUICtrlSetData($Input5,$smallpass)
EndIf
Case $Button12
If $password<>"" Then
$temp=FileSaveDialog("Save as...",@ScriptDir,"Text file (*.txt)",18,"Password.txt",$Form1)
If $temp<>"" Then
SetError(0)
$handle=FileOpen($temp,2)
FileWrite($handle,$password)
FileClose($handle)
If @error<>0 Then MsgBox(16,"ERROR","An error occurred while saving the password as a text file.",0,$Form1)
SetError(0)
EndIf
EndIf
Case $Radio1
If GUICtrlRead($Radio1)=1 And GUICtrlRead($Checkbox1)=1 Then
$temp=Int(GUICtrlRead($Input7))
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21)
ElseIf GUICtrlRead($Radio2)=1 And GUICtrlRead($Checkbox1)=1 Then
$temp=Int(GUICtrlRead($Input7))
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
ElseIf GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
If GUICtrlRead($Radio1)=1 Then
If GUICtrlRead($Edit1)<>$alg1 Then
GUICtrlSetData($Edit1,$alg1)
EndIf
Else
If GUICtrlRead($Edit1)<>$alg2 Then
GUICtrlSetData($Edit1,$alg2)
EndIf
EndIf
Case $Radio2
If GUICtrlRead($Radio1)=1 And GUICtrlRead($Checkbox1)=1 Then
$temp=Int(GUICtrlRead($Input7))
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21)
ElseIf GUICtrlRead($Radio2)=1 And GUICtrlRead($Checkbox1)=1 Then
$temp=Int(GUICtrlRead($Input7))
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
ElseIf GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
If GUICtrlRead($Radio1)=1 Then
If GUICtrlRead($Edit1)<>$alg1 Then
GUICtrlSetData($Edit1,$alg1)
EndIf
Else
If GUICtrlRead($Edit1)<>$alg2 Then
GUICtrlSetData($Edit1,$alg2)
EndIf
EndIf
Case $Checkbox1
If GUICtrlRead($Radio1)=1 And GUICtrlRead($Checkbox1)=1 Then
$temp=Int(GUICtrlRead($Input7))
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21)
ElseIf GUICtrlRead($Radio2)=1 And GUICtrlRead($Checkbox1)=1 Then
$temp=Int(GUICtrlRead($Input7))
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
ElseIf GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
Case $Button4
$temp=Int(GUICtrlRead($Input1))
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp<0 Then $temp=0
GUICtrlSetData($Input1,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button5
$temp=Int(GUICtrlRead($Input1))
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp<0 Then $temp=0
GUICtrlSetData($Input1,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button6
$temp=Int(GUICtrlRead($Input2))
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp<0 Then $temp=0
GUICtrlSetData($Input2,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button7
$temp=Int(GUICtrlRead($Input2))
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp<0 Then $temp=0
GUICtrlSetData($Input2,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button8
$temp=Int(GUICtrlRead($Input3))
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp<0 Then $temp=0
GUICtrlSetData($Input3,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button9
$temp=Int(GUICtrlRead($Input3))
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp<0 Then $temp=0
GUICtrlSetData($Input3,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button10
$temp=Int(GUICtrlRead($Input4))
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp<0 Then $temp=0
GUICtrlSetData($Input4,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button11
$temp=Int(GUICtrlRead($Input4))
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp<0 Then $temp=0
GUICtrlSetData($Input4,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button13
$temp=Int(GUICtrlRead($Input9))
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp<0 Then $temp=0
If StringLen(GUICtrlRead($Input8))=0 Then $temp=0
GUICtrlSetData($Input9,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Button14
$temp=Int(GUICtrlRead($Input9))
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp<0 Then $temp=0
If StringLen(GUICtrlRead($Input8))=0 Then $temp=0
GUICtrlSetData($Input9,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input1
$temp=Int(GUICtrlRead($Input1))
If $temp<0 Then $temp=0
GUICtrlSetData($Input1,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input2
$temp=Int(GUICtrlRead($Input2))
If $temp<0 Then $temp=0
GUICtrlSetData($Input2,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input3
$temp=Int(GUICtrlRead($Input3))
If $temp<0 Then $temp=0
GUICtrlSetData($Input3,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input4
$temp=Int(GUICtrlRead($Input4))
If $temp<0 Then $temp=0
GUICtrlSetData($Input4,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input9
$temp=Int(GUICtrlRead($Input9))
If $temp<0 Then $temp=0
If StringLen(GUICtrlRead($Input8))=0 Then $temp=0
GUICtrlSetData($Input9,$temp)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input6
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Input8
If GUICtrlRead($Input8)="" Then GUICtrlSetData($Input9,0)
If GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
If GUICtrlRead($Input7)<>$temp Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
EndIf
Case $Label12
MsgBox(0,"Symbols","!, @, #, $, %, ^, &, <, >, ?",0,$Form1)
Case $Input7
If GUICtrlRead($Radio1)=1 And GUICtrlRead($Checkbox1)=1 Then
GUICtrlSetData($Input7,Int(GUICtrlRead($Input7)))
EndIf
Case $Button15
GUICtrlDelete($Button15)
$Button15 = GUICtrlCreateButton("Saving...", 432, 320, 121, 25, $WS_DISABLED)
gathersettings()
writesettings()
Sleep(200)
GUICtrlDelete($Button15)
$Button15 = GUICtrlCreateButton("Save settings", 432, 320, 121, 25, 0)
Case $Button17
Dim $settings[11]=[0,0,0,0,"",0,"",1,0,0,0]
applysettings()
EndSwitch
WEnd

Func alg1($param1,$param2,$param3,$param4,$param5,$param6,$param7,$param8)
$temp11=($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7))
If $temp11>5000 Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Generating password...", 354, 80, 164, 17)
Else
If GUICtrlRead($Label13)<>"Status:  Idle" Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Idle", 354, 80, 164, 17)
EndIf
EndIf
$temp=0
$temp2=""
$temp11=($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7))
For $temp=1 To $param1 Step 1
$temp2=$temp2&$a[Random(0,25,1)]
Next
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
For $temp=1 To $param2 Step 1
$temp2=$temp2&$b[Random(0,25,1)]
Next
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
For $temp=1 To $param3 Step 1
$temp2=$temp2&$c[Random(0,9,1)]
Next
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
For $temp=1 To $param4 Step 1
$temp2=$temp2&$d[Random(0,9,1)]
Next
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
$temp2=$temp2&$param5
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
If StringLen($param7)>1 Then
For $temp=1 To $param6
$temp2=$temp2&StringMid($param7,Random(1,StringLen($param7),1),1)
Next
Else
For $temp=1 To $param6
$temp2=$temp2&$param7
Next
EndIf
If $temp11>50000 Then
GUICtrlSetData($Progress1,100)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel("100%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
$temp2=scramble($temp2,$param8)
Return $temp2
EndFunc

Func scramble($param1,$param2)
If $param2>500 Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Scrambling password...", 354, 80, 164, 17)
Else
If GUICtrlRead($Label13)<>"Status:  Idle" Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Idle", 354, 80, 164, 17)
EndIf
EndIf
GUICtrlSetData($Progress1,0)
If GUICtrlRead($Label15)<>"0%" Then
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel("0%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
$temp=0
$temp3=$param1
If StringLen($param1)>1 Then
If $param2<=50000 Then
For $temp=1 To $param2 Step 1
$temp4=Random(1,StringLen($temp3),1)
$temp5=StringMid($temp3,$temp4,1)
$temp6=Random(1,StringLen($temp3),1)
$temp7=StringMid($temp3,$temp6,1)
$temp3=StringLeft($temp3,$temp4-1)&$temp7&StringRight($temp3,StringLen($temp3)-$temp4)
$temp3=StringLeft($temp3,$temp6-1)&$temp5&StringRight($temp3,StringLen($temp3)-$temp6)
Next
Else
$temp10=0
For $temp=1 To 20 Step 1
GUICtrlSetData($Progress1,$temp*5)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp*5)&"%", 520, 80, 31, 17, $SS_RIGHT)
For $temp9=1 To $param2/20 Step 1
$temp10=$temp10+1
$temp4=Random(1,StringLen($temp3),1)
$temp5=StringMid($temp3,$temp4,1)
$temp6=Random(1,StringLen($temp3),1)
$temp7=StringMid($temp3,$temp6,1)
$temp3=StringLeft($temp3,$temp4-1)&$temp7&StringRight($temp3,StringLen($temp3)-$temp4)
$temp3=StringLeft($temp3,$temp6-1)&$temp5&StringRight($temp3,StringLen($temp3)-$temp6)
Next
Next
GUICtrlSetData($Progress1,100)
If GUICtrlRead($Label15)<>"100%" Then
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel("100%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
For $temp=$temp10 To $param2 Step 1
$temp4=Random(1,StringLen($temp3),1)
$temp5=StringMid($temp3,$temp4,1)
$temp6=Random(1,StringLen($temp3),1)
$temp7=StringMid($temp3,$temp6,1)
$temp3=StringLeft($temp3,$temp4-1)&$temp7&StringRight($temp3,StringLen($temp3)-$temp4)
$temp3=StringLeft($temp3,$temp6-1)&$temp5&StringRight($temp3,StringLen($temp3)-$temp6)
Next
EndIf
EndIf
Return $temp3
EndFunc

Func alg2($param1,$param2,$param3,$param4,$param5,$param6,$param7)
; Generate random characters
$temp=""
$temp2=""
$temp3=""
$temp4=""
$temp5=""
$temp6=""
$temp7=""
$temp8=""
$temp9=""
$temp10=""
$temp11=""
$temp12=""
$temp11=($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7))
If $temp11>5000 Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Generating password...", 354, 80, 164, 17)
Else
If GUICtrlRead($Label13)<>"Status:  Idle" Then
GUICtrlDelete($Label13)
$Label13 = GUICtrlCreateLabel("Status:  Idle", 354, 80, 164, 17)
EndIf
EndIf
$temp=0
$temp2=""
$temp11=($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7))
For $temp=1 To $param1 Step 1
$temp2=$temp2&$a[Random(0,25,1)]
Next
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
For $temp=1 To $param2 Step 1
$temp2=$temp2&$b[Random(0,25,1)]
Next
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
For $temp=1 To $param3 Step 1
$temp2=$temp2&$c[Random(0,9,1)]
Next
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
For $temp=1 To $param4 Step 1
$temp2=$temp2&$d[Random(0,9,1)]
Next
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
$temp2=$temp2&$param5
If $temp11>50000 Then
$temp8=Round((StringLen($temp2)/($param1+$param2+$param3+$param4+StringLen($param5)+$param6+StringLen($param7)))*100,0)
GUICtrlSetData($Progress1,$temp8)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel(String($temp8)&"%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
If StringLen($param7)>1 Then
For $temp=1 To $param6
$temp2=$temp2&StringMid($param7,Random(1,StringLen($param7),1),1)
Next
Else
For $temp=1 To $param6
$temp2=$temp2&$param7
Next
EndIf
If $temp11>50000 Then
GUICtrlSetData($Progress1,100)
GUICtrlDelete($Label15)
$Label15 = GUICtrlCreateLabel("100%", 520, 80, 31, 17, $SS_RIGHT)
EndIf
; scramble them strategically random
$temp=""
$temp3=""
$temp4=""
$temp5=$temp2
$temp2=""
$temp6=""
$temp7=""
$temp8=""
$temp9=""
$temp10=""
$temp11=""
$temp12=""
If StringLen($temp5)>1 Then
For $temp9=1 To 20 Step 1
For $temp=1 To StringLen($temp5)-1 Step 1
$temp2=StringMid($temp5,$temp,1)
$temp7=Asc($temp2)
If $temp7<=122 And $temp7>=97 Then
$temp7=1
ElseIf $temp7<=90 And $temp7>=65 Then
$temp7=2
ElseIf $temp7<=57 And $temp7>=48 Then
$temp7=3
ElseIf $temp7=33 Or $temp7=35 Or $temp7=36 Or $temp7=37 Or $temp7=38 Or $temp7=60 Or $temp7=62 Or $temp7=63 Or $temp7=64 Or $temp7=94 Then
$temp7=4
Else
$temp7=5
EndIf
$temp8=$temp7
$temp2=StringMid($temp5,$temp+1,1)
$temp7=Asc($temp2)
If $temp7<=122 And $temp7>=97 Then
$temp7=1
ElseIf $temp7<=90 And $temp7>=65 Then
$temp7=2
ElseIf $temp7<=57 And $temp7>=48 Then
$temp7=3
ElseIf $temp7=33 Or $temp7=35 Or $temp7=36 Or $temp7=37 Or $temp7=38 Or $temp7=60 Or $temp7=62 Or $temp7=63 Or $temp7=64 Or $temp7=94 Then
$temp7=4
Else
$temp7=5
EndIf
If $temp7=$temp8 Then
If Random(1,2,1)=1 Then
$temp10=Random(1,StringLen($temp5),1)
If $temp10=$temp Or $temp10=$temp+1 Then $temp10=$temp10+2
If Random(1,2,1)=1 Then
If $temp10>StringLen($temp5) Then $temp10=0
Else
If $temp10>StringLen($temp5) Then $temp10=StringLen($temp5)
EndIf
If $temp=StringLen($temp5)-1 And $temp10=$temp Then $temp10=0
If $temp=1 And $temp10=1 Then $temp10=StringLen($temp5)
$temp11=StringMid($temp5,$temp+1,1)
$temp5=StringLeft($temp5,$temp)&StringRight($temp5,(StringLen($temp5)-$temp)-1)
$temp5=StringLeft($temp5,$temp10)&$temp11&StringRight($temp5,(StringLen($temp5)-$temp10))
EndIf
EndIf
Next
Next
EndIf
Return $temp5
EndFunc

Func _GroupDigits ($grpdig)
If StringLen($grpdig)>=4 Then
$grpdig2=StringLen($grpdig)
While 1
$grpdig2=$grpdig2-3
If $grpdig2<3 Then ExitLoop
WEnd
$grpdig4=$grpdig4&StringLeft($grpdig,$grpdig2)&","
For $grpdig3=$grpdig2+1 To StringLen($grpdig) Step 3
$grpdig4=$grpdig4&StringMid($grpdig,$grpdig3,3)&","
Next
If StringLeft($grpdig4,1)="," Then $grpdig4=StringRight($grpdig4,StringLen($grpdig4)-1)
If StringRight($grpdig4,1)="," Then $grpdig4=StringLeft($grpdig4,StringLen($grpdig4)-1)
Return $grpdig4
Else
Return $grpdig
EndIf
EndFunc

Func gathersettings()
$settings[0]=Int(GUICtrlRead($Input1))
$settings[1]=Int(GUICtrlRead($Input2))
$settings[2]=Int(GUICtrlRead($Input3))
$settings[3]=Int(GUICtrlRead($Input4))
$settings[4]=GUICtrlRead($Input6)
$settings[5]=Int(GUICtrlRead($Input9))
$settings[6]=GUICtrlRead($Input8)
If GUICtrlRead($Radio1)=1 Then
$settings[7]=1
Else
$settings[7]=2
EndIf
If GUICtrlRead($Checkbox1)=1 Then
$settings[8]=1
Else
$settings[8]=0
EndIf
$settings[9]=Int(GUICtrlRead($Input7))
If GUICtrlRead($Checkbox2)=1 Then
$settings[10]=1
Else
$settings[10]=0
EndIf
EndFunc

Func writesettings()
SetError(0)
$handle=FileOpen("Settings.ini",2)
FileWrite($handle,$settings[0]&@LF&$settings[1]&@LF&$settings[2]&@LF&$settings[3]&@LF&$settings[4]&@LF&$settings[5]&@LF&$settings[6]&@LF&$settings[7]&@LF&$settings[8]&@LF&$settings[9]&@LF&$settings[10])
FileClose($handle)
If @error<>0 Then MsgBox(16,"ERROR","An error occurred while saving the settings.",0,$Form1)
SetError(0)
EndFunc

Func readsettings()
If FileExists("Settings.ini") Then
$handle=FileOpen("Settings.ini",0)
$temp=FileRead($handle)
FileClose($handle)
$temp=StringSplit($temp,@LF)
If $temp[0]<>11 Then
MsgBox(16,"ERROR","The settings file is corrupt or invalid."&@LF&"This will attempt to read the settings."&@LF&"Anything invalid will be ignored and set to default.")
ReDim $temp[12]
EndIf
$settings[0]=Int($temp[1])
$settings[1]=Int($temp[2])
$settings[2]=Int($temp[3])
$settings[3]=Int($temp[4])
$settings[4]=$temp[5]
$settings[5]=Int($temp[6])
$settings[6]=$temp[7]
$settings[7]=Int($temp[8])
$settings[8]=Int($temp[9])
$settings[9]=Int($temp[10])
$settings[10]=Int($temp[11])
If $settings[7]<>1 And $settings[7]<>2 Then $settings[7]=1
If $settings[8]<>0 And $settings[8]<>1 Then $settings[8]=0
If $settings[10]<>0 And $settings[10]<>1 Then $settings[10]=0
EndIf
EndFunc

Func applysettings()
GUICtrlSetData($Input1,$settings[0])
GUICtrlSetData($Input2,$settings[1])
GUICtrlSetData($Input3,$settings[2])
GUICtrlSetData($Input4,$settings[3])
GUICtrlSetData($Input6,$settings[4])
GUICtrlSetData($Input9,$settings[5])
GUICtrlSetData($Input8,$settings[6])
If $settings[7]=1 Then
GUICtrlSetState($Radio1,$GUI_CHECKED)
GUICtrlSetState($Radio2,$GUI_UNCHECKED)
Else
GUICtrlSetState($Radio2,$GUI_CHECKED)
GUICtrlSetState($Radio1,$GUI_UNCHECKED)
EndIf
If $settings[8]=1 Then
GUICtrlSetState($Checkbox1,$GUI_CHECKED)
Else
GUICtrlSetState($Checkbox1,$GUI_UNCHECKED)
EndIf
If GUICtrlRead($Radio1)=1 And GUICtrlRead($Checkbox1)=1 Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput(Int($settings[9]), 168, 224, 161, 21)
ElseIf GUICtrlRead($Radio2)=1 And GUICtrlRead($Checkbox1)=1 Then
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput(Int($settings[9]), 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
ElseIf GUICtrlRead($Checkbox1)<>1 Then
$temp=String((Int(GUICtrlRead($Input1))+Int(GUICtrlRead($Input2))+Int(GUICtrlRead($Input3))+Int(GUICtrlRead($Input4))+Int(GUICtrlRead($Input9))+StringLen(GUICtrlRead($Input6)))*5)
GUICtrlDelete($Input7)
$Input7 = GUICtrlCreateInput($temp, 168, 224, 161, 21, BitOR($ES_AUTOHSCROLL,$ES_READONLY))
EndIf
If $settings[10]=1 Then
GUICtrlSetState($Checkbox2,$GUI_CHECKED)
Else
GUICtrlSetState($Checkbox2,$GUI_UNCHECKED)
EndIf
If GUICtrlRead($Radio1)=1 Then
If GUICtrlRead($Edit1)<>$alg1 Then
GUICtrlSetData($Edit1,$alg1)
EndIf
Else
If GUICtrlRead($Edit1)<>$alg2 Then
GUICtrlSetData($Edit1,$alg2)
EndIf
EndIf
EndFunc

Exit
