#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icon (2).ico
#AutoIt3Wrapper_outfile=Speedcubing Timer.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Speedcubing Timer
#AutoIt3Wrapper_Res_Fileversion=0.2.2.8
#AutoIt3Wrapper_Res_Language=1033
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <StaticConstants.au3>
Global Const $GUI_SHOW = 16
Global Const $GUI_HIDE = 32
Global Const $GUI_ENABLE = 64
Global Const $GUI_DISABLE = 128
Global Const $GUI_FOCUS = 256
Global Const $GUI_NOFOCUS = 8192
Global Const $GUI_CHECKED = 1
Global Const $GUI_UNCHECKED = 4

Opt("GUICloseOnESC", 0)
OnAutoItExitRegister("writesettings")

$reset = 0

If $cmdline[0] >= 2 Then
	If $cmdline[2] = "-reset" Then $reset = 1
	$inipath = $cmdline[1]
ElseIf $cmdline[0] >= 1 Then
	$inipath = $cmdline[1]
Else
	$inipath = @ScriptDir
	If StringRight($inipath, 1) <> "\" Then $inipath &= "\"
	$inipath &= "Speedcubing Timer.ini"
EndIf
$temp = StringInStr($inipath, "|")
If $temp Then $inipath = StringLeft($inipath, $temp)

Dim $ver = "Speedcubing Timer v0.2.2.8", $a = 1, $b = 0, $c = 0, $d = "", $e = "", $f = 0, $h = 0, $m = 0, $s = 0, $temp = 1, $temp2 = 1, $h2, $m2, $s2, $temp3 = 0, $notations[18] = ["L", "U", "F", "R", "D", "B", "L'", "U'", "F'", "R'", "D'", "B'", "L2", "U2", "F2", "R2", "D2", "B2"], $data, $settings, $solves, $solves2, $current = -1, $puzzle = -1, $param = 0, $i, $j, $stop = 0, $toggle = 0, $k, $l = 0, $sleeping = 0, $dnf = 0, $blank = 0, $scramble = "", $addedtime, $paused, $cancel = 0, $showtimes = 0, $comments, $dates, $dnfs, $disable = 0, $param2 = 0, $pzlbut = -1, $paused2 = 0, $no = 0

$Form1 = GUICreate($ver, 681, 608, -1, -1)
$Label1 = GUICtrlCreateLabel("0.00", 8, 8, 665, 129, BitOR($SS_CENTER, $SS_CENTERIMAGE))
GUICtrlSetFont(-1, 84, 400, 0, "Arial")
$Button1 = GUICtrlCreateButton("READY", 8, 144, 569, 57, 1)
GUICtrlSetFont(-1, 14, 400, 0, "Arial")
$Button8 = GUICtrlCreateButton("Pause", 584, 144, 89, 25, 0)
GUICtrlSetState($Button8, 128)
$Button9 = GUICtrlCreateButton("Cancel", 584, 176, 89, 25, 0)
GUICtrlSetState($Button9, 128)
$Label16 = GUICtrlCreateLabel("Scrambler is turned off", 8, 210, 665, 22, BitOR($SS_CENTER, $SS_CENTERIMAGE))
GUICtrlSetFont(-1, 12, 400, 0, "Arial")
$Checkbox5 = GUICtrlCreateCheckbox("Use the 3x3x3 scrambler", 8, 248, 177, 25)
GUICtrlSetState(-1, $GUI_CHECKED)
$Checkbox3 = GUICtrlCreateCheckbox("Auto-focus the start button", 8, 280, 177, 25)
GUICtrlSetState(-1, $GUI_CHECKED)
$Checkbox1 = GUICtrlCreateCheckbox("Use inspection time:", 8, 312, 121, 25)
GUICtrlSetState(-1, $GUI_CHECKED)
$Combo1 = GUICtrlCreateCombo("", 136, 314, 49, 25, 3)
GUICtrlSetData(-1, "|15|10|5|3|2|1", "15")
$Checkbox2 = GUICtrlCreateCheckbox("Record all of the solve times", 8, 344, 177, 25)
GUICtrlSetState(-1, $GUI_CHECKED)
$Label10 = GUICtrlCreateLabel("Best:", 8, 384, 28, 17)
$Label11 = GUICtrlCreateLabel("Best of 5:", 8, 416, 49, 17)
$Label12 = GUICtrlCreateLabel("Best of", 8, 448, 37, 17)
$Input2 = GUICtrlCreateInput("12", 56, 446, 41, 21)
$updown2 = GUICtrlCreateUpdown($Input2, 0xA4)
GUICtrlSetLimit($updown2, 999, 1)
$Label13 = GUICtrlCreateLabel("?", 120, 384, 67, 17)
$Label14 = GUICtrlCreateLabel("?", 120, 416, 67, 17)
$Label15 = GUICtrlCreateLabel("?", 120, 448, 67, 17)
$Label2 = GUICtrlCreateLabel("Average:", 8, 480, 47, 17)
$Label3 = GUICtrlCreateLabel("Average of 5:", 8, 512, 68, 17)
$Label4 = GUICtrlCreateLabel("Average of", 8, 544, 56, 17)
$Input1 = GUICtrlCreateInput("12", 72, 542, 41, 21)
$updown1 = GUICtrlCreateUpdown($Input1, 0xA4)
GUICtrlSetLimit($updown1, 999, 1)
$Label5 = GUICtrlCreateLabel("?", 120, 480, 67, 17)
$Label6 = GUICtrlCreateLabel("?", 120, 512, 67, 17)
$Label7 = GUICtrlCreateLabel("?", 120, 544, 67, 17)
$Button12 = GUICtrlCreateButton("Statistics...", 8, 576, 97, 25, 0)
GUICtrlSetState($Button12, $GUI_DISABLE)
$Button13 = GUICtrlCreateButton("About", 112, 576, 75, 25, 0)
$Label8 = GUICtrlCreateLabel("Puzzles:", 202, 242, 43, 17)
$Label9 = GUICtrlCreateLabel("Date (Y/M/D) --- Time --- Solve time:", 442, 242, 225, 17)
$List1 = GUICtrlCreateList("", 200, 264, 233, 240)
$List2 = GUICtrlCreateList("", 440, 264, 233, 240)
$Button2 = GUICtrlCreateButton("Add", 200, 512, 73, 25, 0)
$Button7 = GUICtrlCreateButton("Edit", 280, 512, 73, 25, 0)
$Button3 = GUICtrlCreateButton("Remove", 360, 512, 73, 25, 0)
$Button4 = GUICtrlCreateButton("Add", 440, 512, 73, 25, 0)
$Button6 = GUICtrlCreateButton("Edit", 520, 512, 73, 25, 0)
$Button5 = GUICtrlCreateButton("Remove", 600, 512, 73, 25, 0)
$Input3 = GUICtrlCreateInput("", 200, 546, 473, 21)
$Button14 = GUICtrlCreateButton("RESET", 200, 576, 81, 25, 0)
$Radio1 = GUICtrlCreateRadio("None", 298, 578, 49, 17)
$Radio2 = GUICtrlCreateRadio("DNF", 362, 578, 49, 17)
$Radio3 = GUICtrlCreateRadio("+2", 426, 578, 49, 17)
$Button10 = GUICtrlCreateButton("Save", 488, 576, 89, 25, 0)
$Button11 = GUICtrlCreateButton("Cancel", 584, 576, 89, 25, 0)

Dim $startstop[3][2] = [["{SPACE}", $Button1],["{Esc}", $Button9],["{p}", $Button8]]

readsettings()
If $settings[0][1] = 2 Then
	GUICtrlSetState($Checkbox5, $GUI_CHECKED)
	GUICtrlSetState($Label16, $GUI_ENABLE)
	scramble()
Else
	GUICtrlSetState($Checkbox5, $GUI_UNCHECKED)
	GUICtrlSetState($Label16, $GUI_DISABLE)
EndIf
If $settings[1][1] = 2 Then
	GUICtrlSetState($Checkbox1, $GUI_CHECKED)
	GUICtrlSetState($Combo1, $GUI_ENABLE)
	GUICtrlSetData($Button1, "READY")
Else
	GUICtrlSetState($Checkbox1, $GUI_UNCHECKED)
	GUICtrlSetState($Combo1, $GUI_DISABLE)
	GUICtrlSetData($Button1, "START")
EndIf
GUICtrlSetData($Combo1, $settings[2][1], $settings[2][1])
If $settings[3][1] = 2 Then
	GUICtrlSetState($Checkbox2, $GUI_CHECKED)
Else
	GUICtrlSetState($Checkbox2, $GUI_UNCHECKED)
EndIf
If $settings[7][1] = 2 Then
	GUICtrlSetState($Checkbox3, $GUI_CHECKED)
Else
	GUICtrlSetState($Checkbox3, $GUI_UNCHECKED)
EndIf
GUICtrlSetData($Input1, $settings[5][1])
GUICtrlSetData($Input2, $settings[6][1])
$d = ""
For $temp3 = 1 To UBound($data) - 1
	$d &= $data[$temp3][0] & "|"
Next
$d = StringTrimRight($d, 1)
GUICtrlSetData($List1, $d, $settings[4][1])
showtimes(-1, $puzzle)
pzlbut()
GUICtrlSetState($Button1, 256)
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case -3
			Exit
		Case $Button1

			If GUICtrlRead($Checkbox1) = 1 Then
				$inspect = GUICtrlRead($Combo1)
			Else
				$inspect = 0
			EndIf

			$addedtime = 0
			$paused = 0
			toggle()

			GUICtrlSetState($Button8, 64)
			GUICtrlSetState($Button9, 64)

			$l = 0

			If $inspect > 0 Then
				GUICtrlSetColor($Label1, 0xff0000)
				While 1
					$nMsg = GUIGetMsg()
					If $nMsg = $Button1 Then
						toggle()
						If $paused Then
							$paused = 0
							GUICtrlSetData($Button8, "Pause")
							GUICtrlSetState($Button1, 256)
						EndIf
						ExitLoop
					ElseIf $nMsg = $Button8 Then; pause/resume
						If $paused Then
							$paused = 0
							$l = 0
							GUICtrlSetData($Button8, "Pause")
							GUICtrlSetState($Button1, 256)
							$b = TimerInit()
						Else
							$addedtime += TimerDiff($b)
							GUICtrlSetData($Button8, "Resume")
							$paused = 1
						EndIf
					ElseIf $nMsg = $Button9 Then; cancel
						toggle(1)
						ExitLoop
					ElseIf $nMsg = -3 Then
						Exit
					EndIf
					If $a = 1 Then ExitLoop
					If $paused = 0 And ($l = 0 Or TimerDiff($l) >= 100) Then
						$c = (TimerDiff($b) + $addedtime) / 1000 - $inspect
						If $c >= 2 Then
							$dnf = 1
							$c = "DNF"
						ElseIf $c >= 0 Then
							$dnf = 2
							$c = "+2 Penalty"
						Else
							$c = String(Int($c))
						EndIf
						If Not (GUICtrlRead($Label1) == $c) Then GUICtrlSetData($Label1, $c)
						$l = TimerInit()
					EndIf
					If $toggle Then
						toggle()
						ExitLoop
					EndIf
				WEnd
				GUICtrlSetColor($Label1, 0)
			EndIf

			While 1

				If $a = 1 Then ExitLoop

				If $paused = 0 Then

					$c = Int((TimerDiff($b) + $addedtime) / 1000)

					If $c > 0 Then

						$e = ""
						$h = Int($c / 3600)
						$c -= $h * 3600
						If $h = 0 Then
							$h2 = ""
						Else
							$h2 = String($h) & ":"
						EndIf

						$m = Int($c / 60)
						$c -= $m * 60
						$e = ""
						If $m < 10 And $h <> 0 Then $e = "0"
						If $m = 0 And $h = 0 Then
							$m2 = ""
						Else
							$m2 = $e & String($m) & ":"
						EndIf

						$s = $c
						$e = ""
						If $s < 10 And ($m <> 0 Or $h <> 0) Then $e = "0"
						$s2 = $e & String($s)

						$c = $h2 & $m2 & $s2

					EndIf

					If Not (GUICtrlRead($Label1) == $c) Then GUICtrlSetData($Label1, $c)

				EndIf

				If $cancel Then
					toggle(1)
					ExitLoop
				EndIf

				If $toggle Then
					toggle()
					ExitLoop
				EndIf

				$sleeping = 1
				Sleep(100)
				$sleeping = 0

			WEnd

		Case $Checkbox5
			If GUICtrlRead($Checkbox5) = 4 Then
				GUICtrlSetData($Label16, "Scrambler is turned off")
				GUICtrlSetState($Label16, $GUI_DISABLE)
			Else
				GUICtrlSetState($Label16, $GUI_ENABLE)
				scramble()
			EndIf
		Case $Checkbox1
			If GUICtrlRead($Checkbox1) = 4 Then
				GUICtrlSetState($Combo1, $GUI_DISABLE)
				GUICtrlSetData($Button1, "START")
			Else
				GUICtrlSetState($Combo1, $GUI_ENABLE)
				GUICtrlSetData($Button1, "READY")
			EndIf
		Case $Checkbox3
			If GUICtrlRead($Checkbox3) = 4 Then
				$settings[7][1] = 1
			Else
				$settings[7][1] = 2
				GUICtrlSetState($Button1, 256)
			EndIf
		Case $List1
			showtimes()
		Case $List2, $Button11
			showinfo()
		Case $Button10
			setinfo()
		Case $Input1, $Input2
			calculate()
		Case $Label1
			GUICtrlSetState($Button1, 256)
		Case $Button2; add puzzle
			$temp4 = InputBox("Add Puzzle", "Enter the name of the new puzzle to add:", "", " M", Default, Default, Default, Default, 0, $Form1)
			If $temp4 <> "" Then
				save()
				ReDim $data[UBound($data) + 1][2]
				$data[UBound($data) - 1][0] = $temp4
				$data[UBound($data) - 1][1] = ""
				$puzzle = UBound($data) - 1
				Dim $blank = 1, $dates[1], $solves[1], $dnfs[1], $comments[1]
				$d = "|"
				For $temp3 = 1 To UBound($data) - 1
					$d &= $data[$temp3][0] & "|"
				Next
				$d = StringTrimRight($d, 1)
				$settings[4][1] = $temp4
				GUICtrlSetData($List1, $d, $temp4)
				GUICtrlSetData($List2, "")
				showinfo()
				calculate()
				pzlbut()
			EndIf
		Case $Button7; edit puzzle
			$temp3 = GUICtrlRead($List1)
			If $temp3 <> "" Then
				$temp4 = InputBox("Edit puzzle", "Edit the puzzle name:", $data[$puzzle][0], " M", Default, Default, Default, Default, 0, $Form1)
				If $temp4 <> "" And Not ($temp4 == $data[$puzzle][0]) Then
					$data[$puzzle][0] = $temp4
					$d = "|"
					For $temp3 = 1 To UBound($data) - 1
						$d &= $data[$temp3][0] & "|"
					Next
					$d = StringTrimRight($d, 1)
					$settings[4][1] = $temp4
					GUICtrlSetData($List1, $d, $temp4)
				EndIf
			EndIf
		Case $Button3; remove puzzle
			$temp3 = GUICtrlRead($List1)
			If $temp3 <> "" And UBound($data) > 2 And MsgBox(308, "Remove puzzle", "Are you sure you want to remove this puzzle and all of its solve times?", 0, $Form1) = 6 Then
				_ArrayDelete($data, $puzzle)
				$d = "|"
				For $temp3 = 1 To UBound($data) - 1
					$d &= $data[$temp3][0] & "|"
				Next
				$d = StringTrimRight($d, 1)
				If $puzzle > UBound($data) - 1 Then $puzzle = UBound($data) - 1
				GUICtrlSetData($List1, $d, $data[$puzzle][0])
				$settings[4][1] = $data[$puzzle][0]
				showtimes(-1, 1)
				pzlbut()
			EndIf
		Case $Button4; add solve time
			$temp4 = InputBox("Add solve time", "Enter a new solve time:", "", " M", Default, Default, Default, Default, 0, $Form1)
			If $temp4 <> "" Then
				fixup()
				addtime($temp4)
			EndIf
		Case $Button6; edit solve time
			$temp3 = GUICtrlRead($List2)
			If $temp3 <> "" Then
				$temp4 = InputBox("Edit solve time", "Edit the solve time:", $solves[$current], " M", Default, Default, Default, Default, 0, $Form1)
				If $temp4 <> "" And Not ($temp4 == $solves[$current]) Then
					fixup()
					$solves[$current] = $temp4
					showtimes($current)
				EndIf
			EndIf
		Case $Button5; remove solve time
			$temp3 = GUICtrlRead($List2)
			If $temp3 <> "" Then
				_ArrayDelete($dates, $current)
				_ArrayDelete($solves, $current)
				_ArrayDelete($dnfs, $current)
				_ArrayDelete($comments, $current)
				showtimes($current)
			EndIf
		Case $Button13
			MsgBox(64, "About", $ver & @LF & "By:  Eric Hbert" & @LF & @LF & "Download more free software at:" & @LF & "http://sites.google.com/site/calcfreak89/", 0, $Form1)
		Case $Button14
			If MsgBox(308, "Warning!", "Are you sure you want to clear all of your puzzles and solve times?", 0, $Form1) = 6 And MsgBox(308, "Warning!", "This cannot be reversed easily!  Are you still sure you want to clear all of your puzzles and solve times?", 0, $Form1) = 6 Then
				FileDelete($inipath)
				GUIDelete($Form1)
				OnAutoItExitUnregister("writesettings")
				MsgBox(64, "Data has been cleared", "All of your puzzles and solve times have been cleared.  Speedcubing Timer will now restart.")
				FileChangeDir(@ScriptDir)
				ShellExecute(@ScriptName, '"' & $inipath & '" -reset')
				Exit
			EndIf
		Case Else
			$no = 1
	EndSwitch
	If $no = 0 And $settings[7][1] = 2 Then GUICtrlSetState($Button1, 256)
	$no = 0
WEnd

Func toggle($param = 0)
	$toggle = 0
	If $a = 1 And $inspect = 0 Then $a = 2
	If $param Then
		GUISetAccelerators("")
		Opt("GUIOnEventMode", 0)
		$a = 1
		If GUICtrlRead($Checkbox1) = 4 Then
			GUICtrlSetData($Button1, "START")
		Else
			GUICtrlSetData($Button1, "READY")
		EndIf
		If $paused Then GUICtrlSetData($Button8, "Pause")
		GUICtrlSetState($Button8, 128)
		GUICtrlSetState($Button9, 128)
		GUICtrlSetState($Checkbox3, 64)
		GUICtrlSetState($Checkbox5, 64)
		$paused = 0
		$cancel = 0
		GUICtrlSetData($Label1, "0.00")
		If GUICtrlRead($Checkbox5) = 1 Then scramble()
		Return
	EndIf
	If $a = 0 Then
		Opt("GUIOnEventMode", 0)
		If $paused Then
			$c = Round($addedtime / 1000, 2)
		Else
			$c = Round((TimerDiff($b) + $addedtime) / 1000, 2)
		EndIf

		If $c > 0 Then

			If $dnf = 2 Then $c += 2

			$d = ""
			$e = ""
			If $c = Int($c) Then $d = ".00"

			$h = Int($c / 3600)
			$c -= $h * 3600
			If $h = 0 Then
				$h2 = ""
			Else
				$h2 = String($h) & ":"
			EndIf

			$m = Int($c / 60)
			$c -= $m * 60
			$e = ""
			If $m < 10 And $h <> 0 Then $e = "0"
			If $m = 0 And $h = 0 Then
				$m2 = ""
			Else
				$m2 = $e & String($m) & ":"
			EndIf

			$s = Round($c, 2)
			$e = ""
			If $s < 10 And ($m <> 0 Or $h <> 0) Then $e = "0"
			$s2 = $e & String($s) & $d
			$e = StringLen($s2) - StringInStr($s2, ".", 0, -1)
			If $e = 0 Then
				$s2 &= "00"
			ElseIf $e = 1 Then
				$s2 &= "0"
			EndIf

			$c = $h2 & $m2 & $s2

			If $dnf = 2 Then $c &= "+"
			If Not (GUICtrlRead($Label1) == $c) Then GUICtrlSetData($Label1, $c)
			If $dnf = 2 Then $c = StringTrimRight($c, 1)

			addtime($c)

		EndIf

		GUISetAccelerators("")
		$a = 1
		If $paused Then GUICtrlSetData($Button8, "Pause")
		$paused = 0
		If GUICtrlRead($Checkbox1) = 4 Then
			GUICtrlSetData($Button1, "START")
		Else
			GUICtrlSetData($Button1, "READY")
		EndIf
		GUICtrlSetState($Button8, 128)
		GUICtrlSetState($Button9, 128)
		GUICtrlSetState($Checkbox3, 64)
		GUICtrlSetState($Checkbox5, 64)
		If GUICtrlRead($Checkbox5) = 1 Then scramble()
	ElseIf $a = 1 Then

		$a = 2
		GUICtrlSetData($Button1, "START")
		GUICtrlSetState($Checkbox3, 128)
		GUICtrlSetState($Checkbox5, 128)
		$b = TimerInit()

	ElseIf $a = 2 Then
		Opt("GUIOnEventMode", 1)
		GUISetAccelerators($startstop)
		GUICtrlSetOnEvent($Button1, "toggle2")
		GUICtrlSetOnEvent($Button8, "pause")
		GUICtrlSetOnEvent($Button9, "cancel")
		GUISetOnEvent(-3, "close")
		GUICtrlSetData($Button1, "STOP")
		GUICtrlSetState($Checkbox3, 128)
		GUICtrlSetState($Checkbox5, 128)
		$a = 0
		$addedtime = 0
		$b = TimerInit()
	EndIf
EndFunc   ;==>toggle

Func toggle2()
	$toggle = 1
	If $sleeping Then toggle()
EndFunc   ;==>toggle2

Func pause()
	If $paused2 Then Return
	$paused2 = 1
	If $paused Then
		$paused = 0
		GUICtrlSetData($Button8, "Pause")
		GUICtrlSetState($Button1, 256)
		$b = TimerInit()
	Else
		$addedtime += TimerDiff($b)
		$temp8 = calctime($addedtime / 1000)
		If Not (GUICtrlRead($Label1) == $temp8) Then GUICtrlSetData($Label1, $temp8)
		GUICtrlSetData($Button8, "Resume")
		$paused = 1
	EndIf
	$paused2 = 0
EndFunc   ;==>pause

Func cancel()
	$cancel = 1
EndFunc   ;==>cancel

Func setinfo()
	$showtimes = 0
	If GUICtrlRead($List2) <> "" Then
		$comments[$current] = GUICtrlRead($Input3)
		If GUICtrlRead($Radio1) = 1 Then
			If $dnfs[$current] = 3 Then plustwo(0)
			If $dnfs[$current] <> 1 Then $showtimes = 1
			$dnfs[$current] = 1
		ElseIf GUICtrlRead($Radio2) = 1 Then
			If $dnfs[$current] = 3 Then plustwo(0)
			If $dnfs[$current] <> 2 Then $showtimes = 1
			$dnfs[$current] = 2
		ElseIf GUICtrlRead($Radio3) = 1 Then
			If $dnfs[$current] <> 3 Then
				plustwo(1)
				$showtimes = 1
			EndIf
			$dnfs[$current] = 3
		EndIf
	EndIf
	If $showtimes Then
		showtimes2($current)
	Else
		calculate()
	EndIf
EndFunc   ;==>setinfo

Func plustwo($param = 0)
	$temp8 = 0
	$temp5 = StringSplit($solves[$current], ":", 3)
	If IsArray($temp5) Then
		$temp7 = 1
		For $temp6 = UBound($temp5) - 1 To 0 Step -1
			$temp8 += Number($temp5[$temp6]) * $temp7
			$temp7 *= 60
		Next
	Else
		$temp8 = Number($temp5)
	EndIf
	If $param Then
		$temp8 += 2
	Else
		$temp8 -= 2
	EndIf
	$solves[$current] = calctime($temp8)
EndFunc   ;==>plustwo

Func showtimes($param = -1, $param2 = 0)
	If $param2 = 0 Then
		save()
		$d = GUICtrlRead($List1)
		$settings[4][1] = $d
		For $temp3 = 1 To UBound($data) - 1
			If $data[$temp3][0] = $d Or $temp3 = UBound($data) - 1 Then
				$puzzle = $temp3
				ExitLoop
			EndIf
		Next
	EndIf
	If $data[$puzzle][1] = "" Then
		Global $blank = 1, $dates[1], $solves[1], $dnfs[1], $comments[1]
		$c = ""
	Else
		$blank = 0
		$solves2 = StringSplit($data[$puzzle][1], "|", 3)
		$c = UBound($solves2)
		Global $dates[$c], $solves[$c], $dnfs[$c], $comments[$c]
		For $temp3 = 0 To UBound($solves2) - 1
			$c = StringSplit($solves2[$temp3], ";", 3)
			ReDim $c[4]
			$dates[$temp3] = $c[0]
			$solves[$temp3] = $c[1]
			$dnfs[$temp3] = $c[2]
			$comments[$temp3] = $c[3]
		Next
		$c = "|"
		For $temp3 = 0 To UBound($solves) - 1
			If $dnfs[$temp3] = 2 Then
				$temp4 = "DNF"
			ElseIf $dnfs[$temp3] = 3 Then
				$temp4 = $solves[$temp3] & "+"
			Else
				$temp4 = $solves[$temp3]
			EndIf
			$c &= $dates[$temp3] & " " & $temp4 & "|"
		Next
		$c = StringTrimRight($c, 1)
	EndIf
	If $param = -1 Then $param = UBound($solves) - 1
	If $param > UBound($solves) - 1 Then $param = UBound($solves) - 1
	If $dnfs[$param] = 2 Then
		$temp4 = "DNF"
	ElseIf $dnfs[$param] = 3 Then
		$temp4 = $solves[$param] & "+"
	Else
		$temp4 = $solves[$param]
	EndIf
	GUICtrlSetData($List2, $c, $dates[$param] & " " & $temp4)
	showinfo()
	calculate()
EndFunc   ;==>showtimes

Func showtimes2($param = -1)
	save()
	$c = "|"
	For $temp3 = 0 To UBound($solves) - 1
		If $dnfs[$temp3] = 2 Then
			$temp4 = "DNF"
		ElseIf $dnfs[$temp3] = 3 Then
			$temp4 = $solves[$temp3] & "+"
		Else
			$temp4 = $solves[$temp3]
		EndIf
		$c &= $dates[$temp3] & " " & $temp4 & "|"
	Next
	$c = StringTrimRight($c, 1)
	If $param = -1 Then $param = UBound($solves) - 1
	If $param > UBound($solves) - 1 Then $param = UBound($solves) - 1
	If $dnfs[$param] = 2 Then
		$temp4 = "DNF"
	ElseIf $dnfs[$param] = 3 Then
		$temp4 = $solves[$param] & "+"
	Else
		$temp4 = $solves[$param]
	EndIf
	GUICtrlSetData($List2, $c, $dates[$param] & " " & $temp4)
	showinfo()
	calculate()
EndFunc   ;==>showtimes2

Func showinfo()
	$i = GUICtrlRead($List2)
	$current = 0
	If $i = "" Then
		If $disable = 0 Then
			GUICtrlSetState($Input3, $GUI_DISABLE)
			GUICtrlSetData($Input3, "")
			GUICtrlSetState($Radio1, $GUI_DISABLE)
			GUICtrlSetState($Radio1, $GUI_UNCHECKED)
			GUICtrlSetState($Radio2, $GUI_DISABLE)
			GUICtrlSetState($Radio2, $GUI_UNCHECKED)
			GUICtrlSetState($Radio3, $GUI_DISABLE)
			GUICtrlSetState($Radio3, $GUI_UNCHECKED)
			GUICtrlSetState($Button10, $GUI_DISABLE)
			GUICtrlSetState($Button11, $GUI_DISABLE)
			GUICtrlSetState($Button6, $GUI_DISABLE)
			GUICtrlSetState($Button5, $GUI_DISABLE)
		EndIf
		$disable = 1
	Else
		For $temp3 = 0 To UBound($solves) - 1
			If $dnfs[$temp3] = 2 Then
				$temp4 = "DNF"
			ElseIf $dnfs[$temp3] = 3 Then
				$temp4 = $solves[$temp3] & "+"
			Else
				$temp4 = $solves[$temp3]
			EndIf
			If $dates[$temp3] & " " & $temp4 = $i Then
				$current = $temp3
				ExitLoop
			EndIf
		Next
		If Int($dnfs[$current]) = 2 Then
			GUICtrlSetState($Radio2, $GUI_CHECKED)
			GUICtrlSetState($Radio1, $GUI_UNCHECKED)
			GUICtrlSetState($Radio3, $GUI_UNCHECKED)
		ElseIf Int($dnfs[$current]) = 3 Then
			GUICtrlSetState($Radio3, $GUI_CHECKED)
			GUICtrlSetState($Radio1, $GUI_UNCHECKED)
			GUICtrlSetState($Radio2, $GUI_UNCHECKED)
		Else
			GUICtrlSetState($Radio1, $GUI_CHECKED)
			GUICtrlSetState($Radio2, $GUI_UNCHECKED)
			GUICtrlSetState($Radio3, $GUI_UNCHECKED)
		EndIf
		GUICtrlSetData($Input3, $comments[$current])
		If $disable Then
			GUICtrlSetState($Input3, $GUI_ENABLE)
			GUICtrlSetState($Radio1, $GUI_ENABLE)
			GUICtrlSetState($Radio2, $GUI_ENABLE)
			GUICtrlSetState($Radio3, $GUI_ENABLE)
			GUICtrlSetState($Button10, $GUI_ENABLE)
			GUICtrlSetState($Button11, $GUI_ENABLE)
			GUICtrlSetState($Button6, $GUI_ENABLE)
			GUICtrlSetState($Button5, $GUI_ENABLE)
		EndIf
		$disable = 0
	EndIf
EndFunc   ;==>showinfo

Func scramble()
	$f = -100
	$g = -200
	$old = -300
	$scramble = ""
	For $k = 1 To 25
		Do
			$g = Random(0, 17, 1)
			$j = $f - 3
			If $j < 0 Then $j += 6
			If $old >= 0 And StringLeft($notations[$g], 1) = StringLeft($notations[$j], 1) And StringLeft($notations[$old], 1) = StringLeft($notations[$g], 1) Then
				$temp3 = 1
				ContinueLoop
			EndIf
			$temp3 = 0
		Until $temp3 <> 1 And $g <> $f And $g <> $f + 6 And $g <> $f + 12 And $g <> $f - 6 And $g <> $f - 12
		$old = $f
		$f = $g
		$scramble &= $notations[$f]
		If $k < 25 Then $scramble &= " "
	Next
	If GUICtrlRead($Label16) <> $scramble Then GUICtrlSetData($Label16, $scramble)
EndFunc   ;==>scramble

Func addtime($param)
	If GUICtrlRead($Checkbox2) = 1 Then
		If $blank = 0 Then ReDim $dates[UBound($dates) + 1], $solves[UBound($solves) + 1], $dnfs[UBound($dnfs) + 1], $comments[UBound($comments) + 1]
		$dates[UBound($dates) - 1] = @YEAR & "/" & @MON & "/" & @MDAY & " --- " & @HOUR & ":" & @MIN & ":" & @SEC & " ---"
		$solves[UBound($solves) - 1] = $param
		If $dnf = 2 Then
			$dnfs[UBound($dnfs) - 1] = 3
		ElseIf $dnf = 1 Then
			$dnfs[UBound($dnfs) - 1] = 2
		Else
			$dnfs[UBound($dnfs) - 1] = 1
		EndIf
		If GUICtrlRead($Checkbox5) = 1 Then
			$comments[UBound($dnfs) - 1] = "Scramble:  " & $scramble
		Else
			$comments[UBound($dnfs) - 1] = ""
		EndIf
		$blank = 0
		showtimes2()
	EndIf
	$dnf = 0
EndFunc   ;==>addtime

Func calculate()
	If $blank Then
		GUICtrlSetData($Label13, "?")
		GUICtrlSetData($Label14, "?")
		GUICtrlSetData($Label15, "?")
		GUICtrlSetData($Label5, "?")
		GUICtrlSetData($Label6, "?")
		GUICtrlSetData($Label7, "?")
		Return
	EndIf
	; best
	Local $temp4, $temp5 = 0, $temp6 = 0, $temp7 = 0, $temp8 = 0, $temp9 = -1, $temp10 = ""
	For $temp4 = 0 To UBound($solves) - 1
		If $dnfs[$temp4] <> 2 Then
			$temp8 = 0
			$temp5 = StringSplit($solves[$temp4], ":", 3)
			If IsArray($temp5) Then
				$temp7 = 1
				For $temp6 = UBound($temp5) - 1 To 0 Step -1
					$temp8 += Number($temp5[$temp6]) * $temp7
					$temp7 *= 60
				Next
			Else
				$temp8 = Number($temp5)
			EndIf
			If $temp9 < 0 Or $temp8 < $temp9 Then
				$temp9 = $temp8
				$temp10 = $solves[$temp4]
			EndIf
		EndIf
	Next
	If $temp9 < 0 Then $temp10 = "DNF"
	If Not (GUICtrlRead($Label13) == $temp10) Then GUICtrlSetData($Label13, $temp10)
	; best of 5
	Local $temp4, $temp5 = 0, $temp6 = 0, $temp7 = 0, $temp8 = 0, $temp9 = -1, $temp10 = "", $temp11 = 1
	For $temp4 = UBound($solves) - 1 To 0 Step -1
		If $dnfs[$temp4] <> 2 Then
			$temp8 = 0
			$temp5 = StringSplit($solves[$temp4], ":", 3)
			If IsArray($temp5) Then
				$temp7 = 1
				For $temp6 = UBound($temp5) - 1 To 0 Step -1
					$temp8 += Number($temp5[$temp6]) * $temp7
					$temp7 *= 60
				Next
			Else
				$temp8 = Number($temp5)
			EndIf
			If $temp9 < 0 Or $temp8 < $temp9 Then
				$temp9 = $temp8
				$temp10 = $solves[$temp4]
			EndIf
		EndIf
		$temp11 += 1
		If $temp11 > 5 Then ExitLoop
	Next
	If $temp9 < 0 Then $temp10 = "DNF"
	If Not (GUICtrlRead($Label14) == $temp10) Then GUICtrlSetData($Label14, $temp10)
	; best of n
	Local $temp4, $temp5 = 0, $temp6 = 0, $temp7 = 0, $temp8 = 0, $temp9 = -1, $temp10 = "", $temp11 = 1, $temp12 = Int(GUICtrlRead($Input2))
	For $temp4 = UBound($solves) - 1 To 0 Step -1
		If $dnfs[$temp4] <> 2 Then
			$temp8 = 0
			$temp5 = StringSplit($solves[$temp4], ":", 3)
			If IsArray($temp5) Then
				$temp7 = 1
				For $temp6 = UBound($temp5) - 1 To 0 Step -1
					$temp8 += Number($temp5[$temp6]) * $temp7
					$temp7 *= 60
				Next
			Else
				$temp8 = Number($temp5)
			EndIf
			If $temp9 < 0 Or $temp8 < $temp9 Then
				$temp9 = $temp8
				$temp10 = $solves[$temp4]
			EndIf
		EndIf
		$temp11 += 1
		If $temp11 > $temp12 Then ExitLoop
	Next
	If $temp9 < 0 Then $temp10 = "DNF"
	If Not (GUICtrlRead($Label15) == $temp10) Then GUICtrlSetData($Label15, $temp10)
	; avg.
	Local $temp4, $temp5 = 0, $temp6 = 0, $temp7 = 0, $temp8 = 0, $temp9 = 0, $temp10 = "", $temp11 = 0
	For $temp4 = 0 To UBound($solves) - 1
		If $dnfs[$temp4] <> 2 Then
			$temp9 += 1
			$temp5 = StringSplit($solves[$temp4], ":", 3)
			If IsArray($temp5) Then
				$temp7 = 1
				For $temp6 = UBound($temp5) - 1 To 0 Step -1
					$temp8 += Number($temp5[$temp6]) * $temp7
					$temp7 *= 60
				Next
			Else
				$temp8 += Number($temp5)
			EndIf
		Else
			$temp11 += 1
		EndIf
	Next
	If $temp11 / UBound($solves) <= .5 Then
		$temp8 /= $temp9
		$temp8 = Round($temp8, 2)
		$temp10 = calctime($temp8)
	Else
		$temp10 = "DNF"
	EndIf
	If Not (GUICtrlRead($Label5) == $temp10) Then GUICtrlSetData($Label5, $temp10)
	; avg. of 5
	Local $temp4, $temp5 = 0, $temp6 = 0, $temp7 = 0, $temp8 = 0, $temp9 = 0, $temp10 = "", $temp11 = 0, $temp12 = 0
	For $temp4 = UBound($solves) - 1 To 0 Step -1
		If $dnfs[$temp4] <> 2 Then
			$temp9 += 1
			$temp5 = StringSplit($solves[$temp4], ":", 3)
			If IsArray($temp5) Then
				$temp7 = 1
				For $temp6 = UBound($temp5) - 1 To 0 Step -1
					$temp8 += Number($temp5[$temp6]) * $temp7
					$temp7 *= 60
				Next
			Else
				$temp8 += Number($temp5)
			EndIf
		Else
			$temp12 += 1
		EndIf
		$temp11 += 1
		If $temp11 > 4 Then ExitLoop
	Next
	If $temp12 / $temp11 <= .5 Then
		$temp8 /= $temp9
		$temp8 = Round($temp8, 2)
		$temp10 = calctime($temp8)
	Else
		$temp10 = "DNF"
	EndIf
	If Not (GUICtrlRead($Label6) == $temp10) Then GUICtrlSetData($Label6, $temp10)
	; avg. of n
	Local $temp4, $temp5 = 0, $temp6 = 0, $temp7 = 0, $temp8 = 0, $temp9 = 0, $temp10 = "", $temp11 = 1, $temp12 = Int(GUICtrlRead($Input1)), $temp13 = 0
	For $temp4 = UBound($solves) - 1 To 0 Step -1
		If $dnfs[$temp4] <> 2 Then
			$temp9 += 1
			$temp5 = StringSplit($solves[$temp4], ":", 3)
			If IsArray($temp5) Then
				$temp7 = 1
				For $temp6 = UBound($temp5) - 1 To 0 Step -1
					$temp8 += Number($temp5[$temp6]) * $temp7
					$temp7 *= 60
				Next
			Else
				$temp8 += Number($temp5)
			EndIf
		Else
			$temp13 += 1
		EndIf
		$temp11 += 1
		If $temp11 > $temp12 Then ExitLoop
	Next
	If $temp13 / ($temp11 - 1) <= .5 Then
		$temp8 /= $temp9
		$temp8 = Round($temp8, 2)
		$temp10 = calctime($temp8)
	Else
		$temp10 = "DNF"
	EndIf
	If Not (GUICtrlRead($Label7) == $temp10) Then GUICtrlSetData($Label7, $temp10)
EndFunc   ;==>calculate

Func calctime($param)
	Local $ct1 = $param, $ct2, $ct3, $ct4, $ct5, $ct6, $ct7, $ct8, $ct9
	$ct2 = ""
	$ct3 = ""
	If $ct1 = Int($ct1) Then $ct2 = ".00"

	$ct5 = Int($ct1 / 3600)
	$ct1 -= $ct5 * 3600
	If $ct5 = 0 Then
		$ct4 = ""
	Else
		$ct4 = String($ct5) & ":"
	EndIf

	$ct7 = Int($ct1 / 60)
	$ct1 -= $ct7 * 60
	$ct3 = ""
	If $ct7 < 10 And $ct5 <> 0 Then $ct3 = "0"
	If $ct7 = 0 And $ct5 = 0 Then
		$ct6 = ""
	Else
		$ct6 = $ct3 & String($ct7) & ":"
	EndIf

	$ct9 = Round($ct1, 2)
	$ct3 = ""
	If $ct9 < 10 And ($ct7 <> 0 Or $ct5 <> 0) Then $ct3 = "0"
	$ct8 = $ct3 & String($ct9) & $ct2
	$ct3 = StringLen($ct8) - StringInStr($ct8, ".", 0, -1)
	If $ct3 = 0 Then
		$ct8 &= "00"
	ElseIf $ct3 = 1 Then
		$ct8 &= "0"
	EndIf

	$ct1 = $ct4 & $ct6 & $ct8

	Return $ct1
EndFunc   ;==>calctime

Func save()
	If $puzzle >= 0 Then
		$data[$puzzle][1] = ""
		If $blank = 0 Then
			For $temp3 = 0 To UBound($solves) - 1
				$data[$puzzle][1] &= $dates[$temp3] & ";" & $solves[$temp3] & ";" & $dnfs[$temp3] & ";" & $comments[$temp3] & "|"
			Next
			$data[$puzzle][1] = StringTrimRight($data[$puzzle][1], 1)
		EndIf
	EndIf
EndFunc   ;==>save

Func fixup()
	$temp8 = 0
	$temp5 = StringSplit($temp4, ":", 3)
	If IsArray($temp5) Then
		$temp7 = 1
		For $temp6 = UBound($temp5) - 1 To 0 Step -1
			$temp8 += Number($temp5[$temp6]) * $temp7
			$temp7 *= 60
		Next
		$temp4 = calctime($temp8)
	Else
		$temp4 = Round($temp4, 2)
	EndIf
	$temp4 = String($temp4)
	$e = StringInStr($temp4, ".", 0, -1)
	If $e = 0 Then
		$temp4 &= ".00"
	Else
		$e = StringLen($temp4) - $e
		If $e = 0 Then
			$temp4 &= "00"
		ElseIf $e = 1 Then
			$temp4 &= "0"
		EndIf
	EndIf
EndFunc   ;==>fixup

Func pzlbut()
	If UBound($data) > 2 Then
		If $pzlbut <> 1 Then
			GUICtrlSetState($Button3, $GUI_ENABLE)
			$pzlbut = 1
		EndIf
	Else
		If $pzlbut <> 0 Then
			GUICtrlSetState($Button3, $GUI_DISABLE)
			$pzlbut = 0
		EndIf
	EndIf
EndFunc   ;==>pzlbut

Func readsettings()
	Global $data, $settings[8][2] = [["UseScrambler", 2],["UseInspectionTime", 2],["InspectionTime", 15],["Record", 2],["LastPuzzle", "3x3x3"],["AverageOf", 12],["BestOf", 12],["AutoFocus", 2]]
	If $reset = 0 And FileExists($inipath) = 0 Then MsgBox(64, "Welcome to Speedcubing Timer!", "This is probably the first time you ran Speedcubing Timer, because the ini file could not be found." & @LF & @LF & "With this program, you can keep track of your solve times with different puzzles.  To start timing, just press and release the spacebar, when you are done timing, press down on the spacebar to stop the timer.  By default, every time you stop timing, that time will be recorded in a list.  There is a customizable list of puzzles that act as seperate categories for all the solve times.  There is optional inspection time which you can change.  You can turn on/off some features by just checking/unchecking the settings.  You can add, edit, and remove puzzles and solve times.  There is a list of statistics that automatically calculate whenever something is changed.  More advanced statistics will be in future versions.")
	$settings[0][1] = Int(IniRead($inipath, "Settings", $settings[0][0], 2))
	If $settings[0][1] <> 1 Then $settings[0][1] = 2
	$settings[1][1] = Int(IniRead($inipath, "Settings", $settings[1][0], 2))
	If $settings[1][1] <> 1 Then $settings[1][1] = 2
	$settings[2][1] = Int(IniRead($inipath, "Settings", $settings[2][0], 15))
	$settings[2][1] = Round($settings[2][1], 0)
	If $settings[2][1] > 15 Then $settings[2][1] = 15
	If $settings[2][1] < 1 Then $settings[2][1] = 1
	$settings[3][1] = Int(IniRead($inipath, "Settings", $settings[3][0], 2))
	If $settings[3][1] <> 1 Then $settings[3][1] = 2
	$settings[4][1] = IniRead($inipath, "Settings", $settings[4][0], "3x3x3")
	$settings[5][1] = Int(IniRead($inipath, "Settings", $settings[5][0], 12))
	$settings[6][1] = Int(IniRead($inipath, "Settings", $settings[6][0], 12))
	$settings[7][1] = Int(IniRead($inipath, "Settings", $settings[7][0], 2))
	If $settings[7][1] <> 1 Then $settings[7][1] = 2
	$data = IniReadSection($inipath, "Data")
	If Not IsArray($data) Then Global $data[2][2] = [[0, 0],["3x3x3", ""]], $blank = 1
	If $settings[4][1] = "" Then $settings[4][1] = $data[UBound($data) - 1][1]
	For $temp3 = 1 To UBound($data) - 1
		If $data[$temp3][0] = $settings[4][1] Or $temp3 = UBound($data) - 1 Then
			$puzzle = $temp3
			ExitLoop
		EndIf
	Next
	$settings[4][1] = $data[$puzzle][0]
EndFunc   ;==>readsettings

Func writesettings()
	save()

	If GUICtrlRead($Checkbox5) = 1 Then
		$settings[0][1] = 2
	Else
		$settings[0][1] = 1
	EndIf
	If GUICtrlRead($Checkbox1) = 1 Then
		$settings[1][1] = 2
	Else
		$settings[1][1] = 1
	EndIf
	$settings[2][1] = Int(GUICtrlRead($Combo1))
	If GUICtrlRead($Checkbox2) = 1 Then
		$settings[3][1] = 2
	Else
		$settings[3][1] = 1
	EndIf
	$settings[5][1] = Int(GUICtrlRead($Input1))
	$settings[6][1] = Int(GUICtrlRead($Input2))

	IniWriteSection($inipath, "Settings", $settings, 0)
	IniWriteSection($inipath, "Data", $data)
EndFunc   ;==>writesettings

Func _ArrayDelete(ByRef $avArray, $iElement)
	If Not IsArray($avArray) Then Return SetError(1, 0, 0)

	Local $iUBound = UBound($avArray, 1) - 1

	If Not $iUBound Then
		$avArray = ""
		Return 0
	EndIf

	If $iElement < 0 Then $iElement = 0
	If $iElement > $iUBound Then $iElement = $iUBound

	Switch UBound($avArray, 0)
		Case 1
			For $i = $iElement To $iUBound - 1
				$avArray[$i] = $avArray[$i + 1]
			Next
			ReDim $avArray[$iUBound]
		Case 2
			Local $iSubMax = UBound($avArray, 2) - 1
			For $i = $iElement To $iUBound - 1
				For $j = 0 To $iSubMax
					$avArray[$i][$j] = $avArray[$i + 1][$j]
				Next
			Next
			ReDim $avArray[$iUBound][$iSubMax + 1]
		Case Else
			Return SetError(3, 0, 0)
	EndSwitch

	Return $iUBound
EndFunc   ;==>_ArrayDelete

Func close()
	Exit
EndFunc   ;==>close