#NoTrayIcon

#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.0.0
 Author:         Eric Hbert

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <File.au3>

Dim $temp="",$lock="Unlock",$combo[4]=[0,0,0,0],$text="",$settings=@ScriptDir&"\Data",$handle=""

If Not FileExists($settings) Then
Dim $temp[5]=[$combo[0],$combo[1],$combo[2],$combo[3],$text]
$handle=FileOpen($settings,2)
_FileWriteFromArray ($settings,$temp)
FileClose($handle)
EndIf
$handle=FileOpen($settings,0)
Dim $combo[4]=[StringLeft(FileReadLine($settings,1),1),StringLeft(FileReadLine($settings,2),1),StringLeft(FileReadLine($settings,3),1),StringLeft(FileReadLine($settings,4),1)]
$text=FileReadLine($settings,5)
FileClose($handle)
If @error=1 Then
MsgBox(16,"ERROR","An error occurred while reading the combination and text.")
$text=""
EndIf
If StringLen($text)>=512 Then $text=StringLeft($text,512)

$Form1 = GUICreate("Virtual Padlock", 315, 151, -1, -1)
$Input1 = GUICtrlCreateInput("0", 40, 16, 22, 21)
$Button1 = GUICtrlCreateButton("-", 16, 15, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Button2 = GUICtrlCreateButton("+", 64, 15, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Input2 = GUICtrlCreateInput("0", 40, 49, 22, 21)
$Button3 = GUICtrlCreateButton("-", 16, 48, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Button4 = GUICtrlCreateButton("+", 64, 48, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Input3 = GUICtrlCreateInput("0", 40, 81, 22, 21)
$Button5 = GUICtrlCreateButton("-", 16, 80, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Button6 = GUICtrlCreateButton("+", 64, 80, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Input4 = GUICtrlCreateInput("0", 40, 113, 22, 21)
$Button7 = GUICtrlCreateButton("-", 16, 112, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Button8 = GUICtrlCreateButton("+", 64, 112, 22, 23, 0)
GUICtrlSetFont(-1, 12, 400, 0, "MS Sans Serif")
$Input5 = GUICtrlCreateInput("", 104, 56, 196, 21, $ES_READONLY)
$Label1 = GUICtrlCreateLabel("Locked text:", 106, 32, 63, 17)
$Button9 = GUICtrlCreateButton($lock, 103, 94, 94, 33, 0)
$Button10 = GUICtrlCreateButton("About", 252, 16, 49, 23, 0)
$Button11=GUICtrlCreateButton("Set combination", 207, 94, 94, 33, $WS_DISABLED)
GUISetState(@SW_SHOW)

While 1
$nMsg = GUIGetMsg()
Switch $nMsg
Case $GUI_EVENT_CLOSE
If $lock="Lock" Then $text=GUICtrlRead($Input5)
If StringLen($text)>=512 Then $text=StringLeft($text,512)
Dim $temp[5]=[$combo[0],$combo[1],$combo[2],$combo[3],$text]
FileClose($handle)
$handle=FileOpen($settings,2)
_FileWriteFromArray ($settings,$temp)
FileClose($handle)
Exit
Case $Input5
If $lock="Lock" Then $text=GUICtrlRead($Input5)
If StringLen($text)>=512 Then $text=StringLeft($text,512)
Case $Button1
$temp=Int(GUICtrlRead($Input1))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input1,$temp)
Case $Button2
$temp=Int(GUICtrlRead($Input1))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input1,$temp)
Case $Button3
$temp=Int(GUICtrlRead($Input2))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input2,$temp)
Case $Button4
$temp=Int(GUICtrlRead($Input2))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input2,$temp)
Case $Button5
$temp=Int(GUICtrlRead($Input3))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input3,$temp)
Case $Button6
$temp=Int(GUICtrlRead($Input3))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input3,$temp)
Case $Button7
$temp=Int(GUICtrlRead($Input4))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp-1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input4,$temp)
Case $Button8
$temp=Int(GUICtrlRead($Input4))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
$temp=$temp+1
If $temp>9 Then $temp=0
If $temp<0 Then $temp=9
GUICtrlSetData($Input4,$temp)
Case $Button9
toggle()
Case $Input1
$temp=Int(GUICtrlRead($Input1))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
GUICtrlSetData($Input1,$temp)
Case $Input2
$temp=Int(GUICtrlRead($Input2))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
GUICtrlSetData($Input2,$temp)
Case $Input3
$temp=Int(GUICtrlRead($Input3))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
GUICtrlSetData($Input3,$temp)
Case $Input4
$temp=Int(GUICtrlRead($Input4))
If $temp>9 Then $temp=9
If $temp<0 Then $temp=0
GUICtrlSetData($Input4,$temp)
Case $Button11
If $lock="Lock" Then
$combo[0]=GUICtrlRead($Input1)
$combo[1]=GUICtrlRead($Input2)
$combo[2]=GUICtrlRead($Input3)
$combo[3]=GUICtrlRead($Input4)
EndIf
Case $Button10
MsgBox(64,"About","Virtual Padlock v2.1.1.0"&@CRLF&"By: Eric Hbert"&@CRLF&"http://calcfreak89.webs.com/",0,$Form1)
EndSwitch
WEnd

Func toggle()
$temp="Unlock"
If $lock="Lock" Then
$temp="Unlock"
$text=GUICtrlRead($Input5)
GUICtrlSetData($Input1,$combo[0])
GUICtrlSetData($Input2,$combo[1])
GUICtrlSetData($Input3,$combo[2])
GUICtrlSetData($Input4,$combo[3])
GUICtrlDelete($Input5)
$Input5=GUICtrlCreateInput("", 104, 56, 196, 21, $ES_READONLY)
Else
If GUICtrlRead($Input1)=$combo[0] and GUICtrlRead($Input2)=$combo[1] and GUICtrlRead($Input3)=$combo[2] and GUICtrlRead($Input4)=$combo[3] Then
$temp="Lock"
GUICtrlDelete($Input5)
$Input5=GUICtrlCreateInput($text, 104, 56, 196, 21)
EndIf
EndIf
$lock=$temp
GUICtrlSetData($Button9,$lock)
If $lock="Unlock" Then
GUICtrlDelete($Button11)
$Button11=GUICtrlCreateButton("Set combination", 207, 94, 94, 33, $WS_DISABLED)
EndIf
If $lock="Lock" Then
GUICtrlDelete($Button11)
$Button11=GUICtrlCreateButton("Set combination", 207, 94, 94, 33, 0)
EndIf
EndFunc